/************************************************/
/*						*/
/*	Procedure definition to manage MySQL	*/
/*	database.				*/
/*						*/
/************************************************/
#ifndef	BASMYS
#define BASMYS
#include	<time.h>
#include	<stdarg.h>
#include	"subsql.h"

typedef	void MYSQLDM;
typedef	void MYSFILE;
typedef	void MYSRESULT;

extern int mys_isdaemonup(const char *host,const char *sqlport,const char *dbname,int tentative);
extern MYSFILE *mys_open(const char *host,const char *sqlport,const char *dbname);
extern MYSFILE *mys_close(MYSFILE *mysfile);
extern const char *mys_getdfltport();
extern int mys_action(MYSFILE *ms,char *command);
extern MYSRESULT *mys_tupple(MYSFILE *ms,char *command);
extern int mys_nbrtupple(MYSRESULT *mysresult);
extern char *mys_getvalue(MYSRESULT *mysresult,int row,char *fieldname);
extern char *mys_getfield(MYSRESULT *mysresult,int row,int column);
extern const char *mys_fromunixtime(time_t timestamp);
extern time_t mys_tounixtime(char *date);
extern u_long mys_date(char *strdate);
extern MYSRESULT *mys_dropresult(MYSRESULT *mysresult);
extern int mys_getlock(MYSFILE *ms,LCKTYP **lcklst);
extern int mys_lock(MYSFILE *ms);
extern int mys_unlock(MYSFILE *ms,int commit);
extern u_vlong mys_getseq(MYSFILE *ms,char *sequence);
extern u_vlong mys_incseq(MYSFILE *ms,char *sequence);
extern char *mys_cleanquote(char *sequence);
extern char *mys_toipbin(char *ipnum);
#endif
