/************************************************/
/*						*/
/*	Procedure definition to manage PosgreSQL*/
/*	database.				*/
/*						*/
/************************************************/
#ifndef	BASPOS
#define BASPOS
#include	<time.h>
#include	<stdarg.h>
#include	"lowtyp.h"
#include	"subsql.h"

typedef	void POSFILE;
typedef	void POSRESULT;
typedef void POSTMASTER;

extern int pos_isdaemonup(const char *host,const char *sqlport,const char *dbname,int tentative);
extern POSFILE *pos_open(const char *host,const char *sqlport,const char *dbname);
extern POSFILE *pos_close(POSFILE *posfile);
extern const char *pos_getdfltport();
extern int pos_action(POSFILE *posfile,char *command);
extern POSRESULT *pos_tupple(POSFILE *posfile,char *command);
extern int pos_nbrtupple(POSRESULT *posresult);
extern POSRESULT *pos_dropresult(POSRESULT *posresult);
extern char *pos_getvalue(POSRESULT *posresult,int row,char *fieldname);
extern char *pos_getfield(POSRESULT *posresult,int row,int column);
extern const char *pos_fromunixtime(time_t timestamp);
extern time_t pos_tounixtime(char *date);
extern int pos_getlock(POSFILE *posfile,LCKTYP **lcklst);
extern int pos_lock(POSFILE *posfile);
extern int pos_unlock(POSFILE *posfile,int commit);
extern u_vlong pos_getseq(POSFILE *posfile,char *sequence);
extern u_vlong pos_incseq(POSFILE *posfile,char *sequence);
extern char *pos_cleanquote(char *sequence);
extern char *pos_toipbin(char *ipnum);
#endif
