#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define yyparse geshdrparse
#define yylex geshdrlex
#define yyerror geshdrerror
#define yychar geshdrchar
#define yyval geshdrval
#define yylval geshdrlval
#define yydebug geshdrdebug
#define yynerrs geshdrnerrs
#define yyerrflag geshdrerrflag
#define yyss geshdrss
#define yyssp geshdrssp
#define yyvs geshdrvs
#define yyvsp geshdrvsp
#define yylhs geshdrlhs
#define yylen geshdrlen
#define yydefred geshdrdefred
#define yydgoto geshdrdgoto
#define yysindex geshdrsindex
#define yyrindex geshdrrindex
#define yygindex geshdrgindex
#define yytable geshdrtable
#define yycheck geshdrcheck
#define yyname geshdrname
#define yyrule geshdrrule
#define yysslim geshdrsslim
#define yystacksize geshdrstacksize
#define YYPREFIX "geshdr"
#line 8 "geshdr.y"
/*force le debugging du YACC                    */
#define lint    1
#ifdef	DEBUG
#define YYDEBUG 1
#endif

#include	<string.h>
#include	<stdio.h>
#include	<setjmp.h>
#include	<syslog.h>
#include	<stdlib.h>
#include	<unistd.h>

#include	"lowtyp.h"
#include	"utlvec.h"
#include	"bascnv.h"
#include	"subclm.h"
#include	"geshdr.h"

int yyparse();		/*syntax parser		*/
static int yylex();	/*lexical parser	*/

/*preamble static function declaration		*/
static int skipfor(char);
static void yyerror(char *);
static char *strmix(char *,char,char *);


#define	MXSTR	60	/*max line size in debug*/

typedef	enum	{	/*header type frame	*/
	hd_from,	/*From:			*/
	hd_to,		/*To:			*/
	hd_cc,		/*Cc:			*/
	hd_bcc,		/*Bcc:			*/
	hd_sender,	/*Sender: 		*/
	hd_replyto,	/*Reply-To: 		*/
	hd_inreplyto,	/*In-Reply-To: 		*/
	hd_references,	/*References: 		*/
	hd_receive,	/*Receive: 		*/
	hd_msgid,	/*Message-ID:		*/
	hd_subject,	/*Subject:		*/
	hd_date		/*Date:			*/
	}HIDTYP;

typedef	struct	{
	HIDTYP field;	/*header field type	*/	
	union {
	  char *time;	/*header date		*/
	  char *address;/*From address		*/
	  char *subject;/*Subject		*/
	  char *receive;/*Receive from field	*/
	  char **maddr;	/*To address		*/
	  char *info;	/*generic		*/
	  }info;
	}HDRTYP;

static HDRTYP **yhdrs;	/*header collected info	*/
static int itsok;	/*parsing status	*/
static jmp_buf manystop;/*YACC fully lost	*/
static int cptstop=0;	/*stop received counting*/

static char **lines;	/*data-header pointer	*/
static int numline;	/*next char header line	*/
static int numrow;	/*next char header row	*/
static int curline;	/*cur char header line	*/
static u_int currow;	/*cur char header row	*/
static int nbrerr;	/*nombre d'erreur	*/
/*

*/
/************************************************/
/*						*/
/*	Procedure to duplicate an header struct	*/
/*						*/
/************************************************/
static HDRTYP *dupheader(HIDTYP field,void *infos)

{
HDRTYP *header;

header=(HDRTYP *)calloc(1,sizeof(HDRTYP));
header->field=field;
if (infos!=(void *)0) {
  switch (field) {
    case (hd_from)	:
    case (hd_sender)	:
    case (hd_replyto)	:
    case (hd_date)	:
      header->info.address=strdup(infos);
      break;
    case (hd_msgid)	:
      header->info.address=strdup(infos);
      break;
    case (hd_receive)	:
      header->info.receive=strdup(infos);
      break;
    case (hd_to)		:
    case (hd_cc)		:
    case (hd_bcc)		:
    case (hd_references)	:
    case (hd_inreplyto)	:
      if (infos!=(void *)0) { /*always		*/
	char **replys;
        register int i;
 
	replys=(char **)0; 
        for (i=0;((char **)infos)[i]!=(char *)0;i++)
  	  replys=(char **)vec_addlstlst((void **)replys,(void *)strdup(((char **)infos)[i]));
        header->info.maddr=replys;
        }
      break;
    case (hd_subject)	:
      header->info.subject=strdup(infos);
      break;
    default		:
      (void) clm_alert(0,"geshdr.y,dupheader: Unexpected field (bug?)");
      break;
    }
  }
return header;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to create the memory space	*/
/*	for a header line			*/
/*						*/
/************************************************/
static HDRTYP *genheader(HIDTYP field,void *infos)

{
HDRTYP *header;

header=(HDRTYP *)calloc(1,sizeof(HDRTYP));
header->field=field;
switch (field) {
  case (hd_from)	:
  case (hd_sender)	:
  case (hd_replyto)	:
  case (hd_date)	:
    (void) clm_strtolower((char *)infos);
    header->info.address=(char *)infos;
    break;
  case (hd_msgid)	:
    header->info.address=(char *)infos;
    break;
  case (hd_receive)	:
    header->info.receive=(char *)infos;
    break;
  case (hd_to)		:
  case (hd_cc)		:
  case (hd_bcc)		:
  case (hd_references)	:
  case (hd_inreplyto)	:
    if (infos!=(char **)0) {
      register int i;

      for (i=0;((char **)infos)[i]!=(char *)0;i++)
        (void) clm_strtolower(((char **)infos)[i]);
      }
    header->info.maddr=(char **)infos;
    break;
  case (hd_subject)	:
    header->info.subject=(char *)infos;
    break;
  default		:
    (void) clm_alert(0,"geshdr.y,genheader: Unexpected field (bug?)");
    break;
  }
return header;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to add a header component to	*/
/*	the header list.			*/
/*						*/
/************************************************/
static HDRTYP **addhdrs(HDRTYP **chdrs,HDRTYP *header)

{
if (header!=(HDRTYP *)0) {
  chdrs=(HDRTYP **)vec_addlstlst((void **)chdrs,(void *)header);
  }
return chdrs;
}
#line 201 "geshdr.y"
typedef union  {
	HDRTYP **hdrs;	/*full header parsed	*/
	HDRTYP *header;	/*one line header	*/
	char *string;	/*the info is a string	*/
	char punct;	/*one char only		*/
	char *word;	/*the info is a word	*/
	char *email;	/*the info is an E-mail	*/
	char **mboxs;	/*multiple Mail boxs	*/
	void *generic;	/*generic value		*/
	long time;	/*time value as a long	*/
	char *strtime;	/*time as a str(long)	*/
	int symbol;	/*token numeric value	*/
	long integer;	/*the value is integer	*/
	float floatting;/*the value is a float	*/
	} YYSTYPE;
#line 251 "geshdr.c"
#define YYERRCODE 256
#define STOP 257
#define CRLF 258
#define COLON 259
#define SEMICOL 260
#define COMMA 261
#define AT 262
#define DOT 263
#define MINUS 264
#define U_LINE 265
#define PLUS 266
#define PARLEFT 267
#define PARRIGHT 268
#define BRKLEFT 269
#define BRKRIGHT 270
#define LESSTHAN 271
#define GRTRTHAN 272
#define QUESTION 273
#define DEBENCOD 274
#define ENCODFIN 275
#define PUNCT 276
#define DATE 277
#define RDATE 278
#define FROM 279
#define SUBJECT 280
#define REPLYTO 281
#define INRPLYTO 282
#define RFERENCE 283
#define RECEIVE 284
#define SENDER 285
#define MSGID 286
#define TO 287
#define CC 288
#define BCC 289
#define WORD 290
#define STRING 291
#define JAN 292
#define FEB 293
#define MAR 294
#define APR 295
#define MAY 296
#define JUN 297
#define JUL 298
#define AUG 299
#define SEP 300
#define OCT 301
#define NOV 302
#define DEC 303
#define MON 304
#define TUE 305
#define WED 306
#define THU 307
#define FRI 308
#define SAT 309
#define SUN 310
const short geshdrlhs[] = {                                        -1,
    0,    0,    1,    1,    2,    3,    3,    3,    3,    3,
    3,    8,    8,    8,    8,    4,   10,   10,   10,    5,
    5,   12,   12,   14,    7,    7,    7,    7,    7,   15,
   17,   19,   18,   18,   20,   20,   16,   16,   16,   16,
   16,    6,    6,   23,   24,   25,   25,   27,   27,   28,
   29,   29,   29,   32,   32,   34,   35,   33,   33,   37,
   37,   38,   38,   39,   39,   13,   13,   13,   42,   42,
   42,   41,   41,   11,   11,   11,   11,   11,   11,   11,
   21,   21,   21,   22,   22,   46,   46,   45,   45,   45,
   47,   47,   48,   48,   48,   48,   49,   49,   51,   44,
   44,   44,   44,   44,   52,   43,   43,   43,   40,   40,
   54,   53,   30,   50,   50,    9,    9,    9,    9,   55,
   55,   55,   55,   55,   56,   56,   56,   56,   56,   56,
   56,   31,   31,   31,   31,   31,   31,   31,   31,   31,
   31,   31,   31,   26,   26,   26,   26,   26,   26,   26,
   36,   36,   36,
};
const short geshdrlen[] = {                                         2,
    2,    2,    1,    2,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    1,    0,    1,    2,    3,    3,    2,    1,
    1,    1,    1,    3,    3,    3,    1,    2,    1,    3,
    2,    1,    1,    5,    3,    1,    1,    3,    1,    3,
    0,    1,    2,    1,    1,    1,    1,    0,    4,    3,
    3,    1,    3,    1,    2,    1,    2,    3,    2,    1,
    3,    2,    3,    1,    3,    1,    2,    1,    3,    3,
    1,    1,    1,    2,    2,    2,    3,    2,    0,    4,
    3,    2,    3,    3,    3,    1,    2,    1,    1,    1,
    0,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    2,
};
const short geshdrdefred[] = {                                      0,
    0,  121,  124,  122,   13,   14,  123,  120,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   10,  132,  133,  134,  135,  136,  137,  138,  139,
  140,  141,  142,  143,  145,  146,  147,  148,  149,  150,
  144,    0,    0,    3,    0,    6,    7,    8,    9,   11,
   12,    0,    0,    0,    0,    0,    0,   42,   43,  118,
  119,  116,  117,    2,    0,    0,   17,   29,   19,   31,
   32,   27,   18,   30,   22,   23,   24,   15,    1,    4,
    5,    0,  111,  125,  129,  131,  130,  126,  127,  128,
  114,  108,  115,   16,    0,    0,   86,    0,    0,    0,
  109,  110,   72,   20,    0,   67,    0,   21,    0,   40,
   41,   25,   35,   26,    0,   28,  113,   44,    0,   47,
    0,    0,   45,    0,    0,  102,    0,    0,    0,    0,
    0,   75,    0,    0,    0,  107,   79,    0,    0,   87,
    0,    0,   39,    0,    0,    0,   36,    0,  151,    0,
    0,   48,   56,    0,   53,    0,    0,    0,  104,    0,
   99,    0,   88,    0,   92,   93,  101,  103,    0,  112,
   78,    0,    0,    0,   73,   70,    0,   37,   38,   46,
  153,   59,   51,    0,    0,   50,   98,    0,  105,    0,
   95,   96,   94,  100,   69,   57,    0,    0,   58,   97,
    0,   89,    0,   65,    0,   62,   64,   54,   60,   63,
};
const short geshdrdgoto[] = {                                      42,
   43,   44,   45,   46,   47,   48,   49,   50,   93,   52,
  103,   53,  104,   54,   55,  113,   56,  114,   57,  115,
   95,   96,   58,   59,  118,   60,  120,  121,  152,  122,
   61,  154,  155,  156,  197,  157,  199,  205,  206,   97,
  105,  106,   98,   99,  162,  100,  163,  164,  165,  101,
  188,  130,  102,  131,   62,   63,
};
const short geshdrsindex[] = {                                    -99,
 -232,    0,    0,    0,    0,    0,    0,    0, -223, -187,
 -177, -172, -158, -155, -153, -152, -146, -145, -144, -139,
 -138,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -154,    0, -149,    0,    0,    0,    0,    0,
    0,  372,  372,  372,  513,  513,  513,    0,    0,    0,
    0,    0,    0,    0,  581,  581,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -44,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -244, -166,    0, -241,  419,  560,
    0,    0,    0,    0, -124,    0, -228,    0,  466,    0,
    0,    0,    0,    0,  513,    0,    0,    0, -103,    0,
 -231,  601,    0, -113,   11,    0, -111, -202, -210,  560,
 -106,    0, -244,   66,  560,    0,    0, -127,  560,    0,
  372,  227,    0,  -97, -234,  560,    0, -114,    0,  -72,
    0,    0,    0, -195,    0,  -46, -114, -114,    0, -186,
    0, -239,    0,  121,    0,    0,    0,    0,  -58,    0,
    0, -186,  -48,  560,    0,    0, -196,    0,    0,    0,
    0,    0,    0, -114,  -51,    0,    0,  -53,    0,  176,
    0,    0,    0,    0,    0,    0,  -40,  325,    0,    0,
 -186,    0, -114,    0,  276,    0,    0,    0,    0,    0,
};
const short geshdrrindex[] = {                                      0,
  -34,    0,    0,    0,    0,    0,    0,    0,  -31,    0,
  -27,    0,  -24,    0,    0,    0,  -18,    0,  -16,   14,
   16,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   20,   20,    0,   21,   21,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -98,  -90,    0,    0,  -35, -183,
    0,    0,    0,    0,   25,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   28,    0,    0,    0,    0,    0,
   31,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  120,    0,    0,    0,  -22, -243,    0,
    0,    0,    0,    0,    0, -178,    0,    0,    0,   -5,
 -159,    0,    0,   33,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   10,    0,    0,    0,    0,    0,    0,
    0,  175,  287,  620,    0,    0,   35,    0,    0,    0,
    0,    0,    0,    0,   36,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -245,    0,    0,    0,
   65,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
const short geshdrgindex[] = {                                      0,
    0,  252,    0,    0,    0,    0,    0,    0,    1,    0,
  -50,    0,  243,    0,    0,  -49,    0,  245,    0,    0,
  -77,  -75,    0,    0,  261,   27,  181,    0,    0, -117,
  211,    0,  180,    0,  135,    0,    0,    0,  136, -100,
  198,    0,  -45,  -84,  210,  -83,  156,    0, -150, -122,
    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 904
const short geshdrtable[] = {                                     140,
   51,   94,  166,  153,  127,  112,  128,  107,  107,  187,
  132,  166,   55,  137,  106,  139,  106,  106,   55,  189,
   55,  187,  137,  190,   64,  146,   82,  134,  135,   82,
  142,  144,  149,  145,  150,   65,  129,  179,  140,  185,
  186,  193,   82,   51,   55,  140,  146,  106,  171,  136,
  187,  174,  169,  138,  128,  111,  111,  111,  151,  134,
  135,  168,  136,  195,  141,  147,  196,  166,  149,  160,
  150,   66,   84,  140,   84,  106,   84,   84,   84,   84,
  136,   67,  161,   84,   84,  196,   68,  106,  106,  133,
  175,  119,  119,   84,  182,  134,  135,  207,   59,  113,
   69,   78,   79,   70,  207,   71,   72,  106,   81,    2,
    3,    4,   73,   74,   75,  111,    5,    6,    7,   76,
   77,    8,    9,   10,   11,   12,   13,   14,   15,   16,
   17,   18,   19,   20,   21,   22,  141,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,   41,    1,  148,  159,   74,
  167,   74,   74,  136,    2,    3,    4,   80,  170,   80,
   80,    5,    6,    7,  178,  117,    8,    9,   10,   11,
   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
   22,  181,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
   41,  124,  184,  194,  190,  198,  200,  125,  203,    2,
    3,    4,   76,   15,   76,   76,  125,  126,    7,   83,
  129,    8,   84,  131,   85,   77,   86,   77,   77,  130,
   87,  126,   88,   89,   90,   91,   92,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,   41,  160,   91,   91,   91,
   91,  127,   91,  128,    2,    3,    4,   68,   34,  161,
   91,   91,   66,    7,  152,   33,    8,   84,   49,   85,
   52,   86,   71,   61,   80,   87,  108,   88,   89,   90,
   91,  116,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
   41,  172,   90,   90,   90,   90,  123,   90,  180,    2,
    3,    4,  158,  183,  161,   90,   90,  208,    7,  177,
  210,    8,   84,  173,   85,  202,   86,    0,    0,    0,
   87,    0,   88,   89,   90,   91,    0,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,   41,  191,   82,    0,   82,
   82,    0,    0,    0,    2,    3,    4,    0,    0,    0,
   82,   82,    0,    7,    0,    0,    8,   84,    0,   85,
    0,   86,    0,    0,    0,   87,    0,   88,   89,   90,
   91,  192,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
   41,  201,   83,    0,   83,   83,    0,    0,    0,    2,
    3,    4,    0,    0,  161,   83,   83,    0,    7,    0,
    0,    8,   84,    0,   85,    0,   86,    0,    0,    0,
   87,    0,   88,   89,   90,   91,    0,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,   41,  176,    0,    0,    0,
    2,    3,    4,    0,    0,    0,    0,   82,    0,    7,
   83,    0,    8,   84,    0,   85,    0,   86,    0,    0,
    0,   87,    0,   88,   89,   90,   91,   92,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
   35,   36,   37,   38,   39,   40,   41,  204,    0,    2,
    3,    4,    0,  209,   81,    0,   81,   81,    7,   83,
    0,    8,   84,    0,   85,    0,   86,   81,   81,    0,
   87,    0,   88,   89,   90,   91,    0,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,   41,  204,    0,    2,    3,
    4,    0,    0,    0,    0,    0,    0,    7,   83,    0,
    8,   84,    0,   85,    0,   86,    0,    0,    0,   87,
    0,   88,   89,   90,   91,    0,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
   37,   38,   39,   40,   41,    2,    3,    4,    0,    0,
    0,    0,   82,    0,    7,   83,    0,    8,   84,    0,
   85,    0,   86,    0,    0,    0,   87,    0,   88,   89,
   90,   91,   92,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,   41,    2,    3,    4,    0,    0,    0,    0,    0,
    0,    7,   83,    0,    8,   84,    0,   85,    0,   86,
    0,    0,    0,   87,    0,   88,   89,   90,   91,   92,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,   41,    2,
    3,    4,    0,    0,    0,    0,    0,  143,    7,   83,
    0,    8,   84,    0,   85,    0,   86,    0,    0,    0,
   87,    0,   88,   89,   90,   91,    0,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,   39,   40,   41,    2,    3,    4,    0,
    0,    0,    0,  109,    0,    7,    0,    0,    8,   84,
    0,   85,    0,   86,    0,    0,    0,   87,    0,   88,
   89,   90,  110,    0,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,   41,    2,    3,    4,    0,    0,    0,    0,
    0,    0,    7,   83,    0,    8,   84,    0,   85,    0,
   86,    0,    0,    0,   87,    0,   88,   89,   90,   91,
    0,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
  117,    0,    0,    0,    0,   85,    0,   85,    0,   85,
   85,   85,   85,    0,   35,   36,   37,   38,   39,   40,
   41,   85,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,
};
const short geshdrcheck[] = {                                     100,
    0,   52,  125,  121,   82,   55,   82,   53,   54,  160,
   95,  134,  258,   98,  258,   99,  260,  261,  264,  259,
  266,  172,  107,  263,  257,  109,  271,  262,  263,  271,
  259,  109,  264,  109,  266,  259,   82,  272,  139,  157,
  158,  164,  271,   43,  290,  146,  130,  291,  133,  291,
  201,  135,  130,   99,  130,   55,   56,   57,  290,  262,
  263,  272,  291,  260,  261,  115,  184,  190,  264,  256,
  266,  259,  256,  174,  258,  259,  260,  261,  262,  263,
  291,  259,  269,  262,  263,  203,  259,  271,  272,  256,
  141,   65,   66,  272,  290,  262,  263,  198,  258,  259,
  259,  256,  257,  259,  205,  259,  259,  291,  258,  264,
  265,  266,  259,  259,  259,  115,  271,  272,  273,  259,
  259,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  261,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  256,  261,  272,  258,
  272,  260,  261,  291,  264,  265,  266,  258,  275,  260,
  261,  271,  272,  273,  272,  290,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  264,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  256,  259,  272,  263,  267,  270,  262,  259,  264,
  265,  266,  258,  258,  260,  261,  258,  272,  273,  274,
  258,  276,  277,  258,  279,  258,  281,  260,  261,  258,
  285,  258,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  256,  258,  259,  260,
  261,  258,  263,  258,  264,  265,  266,  258,  258,  269,
  271,  272,  258,  273,  290,  258,  276,  277,  258,  279,
  258,  281,  258,  258,   43,  285,   54,  287,  288,  289,
  290,   57,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  256,  258,  259,  260,  261,   66,  263,  148,  264,
  265,  266,  122,  154,  269,  271,  272,  203,  273,  142,
  205,  276,  277,  134,  279,  190,  281,   -1,   -1,   -1,
  285,   -1,  287,  288,  289,  290,   -1,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  256,  258,   -1,  260,
  261,   -1,   -1,   -1,  264,  265,  266,   -1,   -1,   -1,
  271,  272,   -1,  273,   -1,   -1,  276,  277,   -1,  279,
   -1,  281,   -1,   -1,   -1,  285,   -1,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  256,  258,   -1,  260,  261,   -1,   -1,   -1,  264,
  265,  266,   -1,   -1,  269,  271,  272,   -1,  273,   -1,
   -1,  276,  277,   -1,  279,   -1,  281,   -1,   -1,   -1,
  285,   -1,  287,  288,  289,  290,   -1,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  260,   -1,   -1,   -1,
  264,  265,  266,   -1,   -1,   -1,   -1,  271,   -1,  273,
  274,   -1,  276,  277,   -1,  279,   -1,  281,   -1,   -1,
   -1,  285,   -1,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,  262,   -1,  264,
  265,  266,   -1,  268,  258,   -1,  260,  261,  273,  274,
   -1,  276,  277,   -1,  279,   -1,  281,  271,  272,   -1,
  285,   -1,  287,  288,  289,  290,   -1,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  262,   -1,  264,  265,
  266,   -1,   -1,   -1,   -1,   -1,   -1,  273,  274,   -1,
  276,  277,   -1,  279,   -1,  281,   -1,   -1,   -1,  285,
   -1,  287,  288,  289,  290,   -1,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,  310,  264,  265,  266,   -1,   -1,
   -1,   -1,  271,   -1,  273,  274,   -1,  276,  277,   -1,
  279,   -1,  281,   -1,   -1,   -1,  285,   -1,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  264,  265,  266,   -1,   -1,   -1,   -1,   -1,
   -1,  273,  274,   -1,  276,  277,   -1,  279,   -1,  281,
   -1,   -1,   -1,  285,   -1,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  264,
  265,  266,   -1,   -1,   -1,   -1,   -1,  272,  273,  274,
   -1,  276,  277,   -1,  279,   -1,  281,   -1,   -1,   -1,
  285,   -1,  287,  288,  289,  290,   -1,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  264,  265,  266,   -1,
   -1,   -1,   -1,  271,   -1,  273,   -1,   -1,  276,  277,
   -1,  279,   -1,  281,   -1,   -1,   -1,  285,   -1,  287,
  288,  289,  290,   -1,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  264,  265,  266,   -1,   -1,   -1,   -1,
   -1,   -1,  273,  274,   -1,  276,  277,   -1,  279,   -1,
  281,   -1,   -1,   -1,  285,   -1,  287,  288,  289,  290,
   -1,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  290,   -1,   -1,   -1,   -1,  256,   -1,  258,   -1,  260,
  261,  262,  263,   -1,  304,  305,  306,  307,  308,  309,
  310,  272,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,
};
#define YYFINAL 42
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 310
#if YYDEBUG
const char * const geshdrname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"STOP","CRLF","COLON","SEMICOL",
"COMMA","AT","DOT","MINUS","U_LINE","PLUS","PARLEFT","PARRIGHT","BRKLEFT",
"BRKRIGHT","LESSTHAN","GRTRTHAN","QUESTION","DEBENCOD","ENCODFIN","PUNCT",
"DATE","RDATE","FROM","SUBJECT","REPLYTO","INRPLYTO","RFERENCE","RECEIVE",
"SENDER","MSGID","TO","CC","BCC","WORD","STRING","JAN","FEB","MAR","APR","MAY",
"JUN","JUL","AUG","SEP","OCT","NOV","DEC","MON","TUE","WED","THU","FRI","SAT",
"SUN",
};
const char * const geshdrrule[] = {
"$accept : email",
"email : headers STOP",
"email : error STOP",
"headers : header",
"headers : headers header",
"header : data CRLF",
"data : originator",
"data : destination",
"data : dates",
"data : optionalfield",
"data : WORD",
"data : scrap",
"scrap : others",
"scrap : LESSTHAN",
"scrap : GRTRTHAN",
"scrap : error",
"originator : senders mailbox",
"senders : FROM COLON",
"senders : SENDER COLON",
"senders : REPLYTO COLON",
"destination : rcpts address",
"destination : bcc address",
"rcpts : TO COLON",
"rcpts : CC COLON",
"bcc : BCC COLON",
"optionalfield : hmsgid msgid",
"optionalfield : inrplyto mulids",
"optionalfield : RECEIVE COLON",
"optionalfield : references mulids",
"optionalfield : SUBJECT COLON",
"hmsgid : MSGID COLON",
"inrplyto : INRPLYTO COLON",
"references : RFERENCE COLON",
"mulids : msgids",
"mulids :",
"msgids : msgid",
"msgids : msgids msgid",
"msgid : LESSTHAN addrspec GRTRTHAN",
"msgid : LESSTHAN localpart GRTRTHAN",
"msgid : LESSTHAN GRTRTHAN",
"msgid : WORD",
"msgid : others",
"dates : origdate",
"dates : resentdate",
"origdate : DATE COLON datetime",
"resentdate : RDATE COLON datetime",
"datetime : days COMMA cachet",
"datetime : cachet",
"cachet : date time",
"cachet : date",
"date : integer months integer",
"time : hours zone",
"time : hours",
"time : zone",
"hours : hour COLON sixty COLON sixty",
"hours : hour COLON sixty",
"hour : integer",
"sixty : integer",
"zone : sign integer optime",
"zone : WORD",
"optime : PARLEFT comments PARRIGHT",
"optime :",
"comments : comment",
"comments : comments comment",
"comment : word",
"comment : AT",
"address : mailboxlist",
"address : group",
"address :",
"group : words COLON mailboxlist SEMICOL",
"group : words COLON SEMICOL",
"group : words COLON mailboxlist",
"mailboxlist : mailbox",
"mailboxlist : mailboxlist COMMA mailbox",
"mailbox : addrspec",
"mailbox : addrspec routeaddr",
"mailbox : routeaddr",
"mailbox : routeaddr words",
"mailbox : localpart error routeaddr",
"mailbox : words routeaddr",
"mailbox : localpart",
"addrspec : localpart AT domain",
"addrspec : localpart AT",
"addrspec : localpart AT error",
"localpart : locals",
"localpart : localpart DOT locals",
"locals : word",
"locals : locals word",
"domain : subdomain",
"domain : domain DOT subdomain",
"domain : domain DOT error",
"subdomain : domainref",
"subdomain : domainliteral",
"domainref : atom",
"domainref : domainref atom",
"domainref : domainref error",
"domainref : domainref STRING",
"domainliteral : BRKLEFT dtext BRKRIGHT",
"domainliteral : error domainliteral",
"dtext :",
"routeaddr : LESSTHAN route addrspec GRTRTHAN",
"routeaddr : LESSTHAN addrspec GRTRTHAN",
"routeaddr : LESSTHAN GRTRTHAN",
"routeaddr : LESSTHAN words GRTRTHAN",
"routeaddr : LESSTHAN error GRTRTHAN",
"route : AT domain COLON",
"words : locals",
"words : words STRING",
"words : STRING",
"word : atom",
"word : encode",
"$$1 :",
"encode : DEBENCOD $$1 ENCODFIN",
"integer : WORD",
"atom : WORD",
"atom : others",
"others : punctuation",
"others : marker",
"others : days",
"others : months",
"punctuation : PUNCT",
"punctuation : MINUS",
"punctuation : PLUS",
"punctuation : QUESTION",
"punctuation : U_LINE",
"marker : DATE",
"marker : TO",
"marker : CC",
"marker : BCC",
"marker : FROM",
"marker : SENDER",
"marker : REPLYTO",
"months : JAN",
"months : FEB",
"months : MAR",
"months : APR",
"months : MAY",
"months : JUN",
"months : JUL",
"months : AUG",
"months : SEP",
"months : OCT",
"months : NOV",
"months : DEC",
"days : SUN",
"days : MON",
"days : TUE",
"days : WED",
"days : THU",
"days : FRI",
"days : SAT",
"sign : MINUS",
"sign : PLUS",
"sign : PLUS MINUS",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 1257 "geshdr.y"
#include	<memory.h>
#include	<ctype.h>
#include	<errno.h>

typedef	enum	{	/*email directive	*/
	mh_orgn,	/*E-mail physic origine	*/
	mh_from,	/*E-mail sender name	*/
	mh_rcpt,	/*E-mail recipient	*/
	mh_data		/*E-mail data phase	*/
	}MHTYP;

/*	Token list				*/
static struct	{
	int code;
	char *string;
	}vocable[]={	/*string MUST be in length order	*/
		   {INRPLYTO,	"In-Reply-To"},
		   {RDATE,	"Resent-Date"},
		   {MSGID,	"Message-ID"},
		   {RFERENCE,	"References"},
		   {REPLYTO,	"Reply-To"},
		   {RECEIVE,	"Received"},
		   {SUBJECT,	"Subject"},
		   {SENDER,	"Sender"},
		   {DATE,	"Date"},
		   {FROM,	"From"},
		   {BCC,	"Bcc"},
		   {MON,"Mon"},{TUE,"Tue"},{WED,"Wed"},{THU,"Thu"},
		   {FRI,"Fri"},{SAT,"Sat"},{SUN,"Sun"},
		   {JAN,"Jan"},{FEB,"Feb"},{MAR,"Mar"},{APR,"Apr"},
		   {MAY,"May"},{JUN,"Jun"},{JUL,"Jul"},{AUG,"Aug"},
		   {SEP,"Sep"},{OCT,"Oct"},{NOV,"Nov"},{DEC,"Dec"},
		   {TO,		"To"},
		   {CC,		"Cc"},
		   {WORD,(char *)0}
		   };
/*

*/
/************************************************/
/*						*/
/*	Procedure to allocate a memory being	*/
/*	the contents of 2 memories, separated	*/
/*	by charactere (free the 2 previously	*/
/*	allocated memories)			*/
/*						*/
/************************************************/
static char *strmix(char *part1,char sep,char *part2)

{
char *mix;

mix=(char *)0;
if (part1==(char *)0)
  part1=strdup("");
if (part2==(char *)0)
  part2=strdup("");
if (sep!='\000') 
  (void) asprintf(&mix,"%s%c%s",part1,sep,part2);
else
  (void) asprintf(&mix,"%s%s",part1,part2);
(void) free(part2);
(void) free(part1);
return mix;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to really clean the YACC	*/
/*	satructure.				*/
/*						*/
/************************************************/
static void cleanyyparse()

{
#ifdef	YYINITSTACKSIZE
#if	YYPATCH >= 20100216
/*procedure already included byacc-1.9		*/
#else
/*to free yyparse dynamically allocated memory	*/
if (yyvs!=(YYSTYPE *)0) {
  (void) free(yyvs);
  yyvs=(YYSTYPE *)0;
  }
if (yyss!=(short *)0) {
  (void) free(yyss);
  yyss=(short *)0;
  }
yystacksize=0;
#endif
#endif
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to report a parsing error	*/
/*	debugging mode only.			*/
/*						*/
/************************************************/
static void yyerror(char *info)

{
int dbg;

dbg=0;
if ((clm_foreground==true)||(debug>=dbg)) {
  int i;
  char crlf[3];

  (void) strcpy(crlf,"");
  for (i=0;lines[curline][i]!='\000';i++)
    if (isspace(lines[curline][i])!=false)
      lines[curline][i]=' ';
  if (currow>=strlen(lines[curline]))
    (void) strcpy(crlf,"\r\n");
  (void) clm_alert(dbg,"% 6d %.*s",curline+1,currow+2,lines[curline]);
  (void) clm_alert(dbg,"%*s %*s%s",6,"",currow+1,"^",info);
  }
nbrerr++;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the punct char	*/
/*	value.					*/ 	
/*						*/
/************************************************/
static int punctchar(char c)

{
int code;

code=PUNCT;
switch (c) {
  case '\n'	:
    code=CRLF;
    break;
  case ':'	:
    code=COLON;
    break;
  case ';'	:
    code=SEMICOL;
    break;
  case ','	:
    code=COMMA;
    break;
  case '@'	:
    code=AT;
    break;
  case '.'	:
    code=DOT;
    break;
  case '-'	:
    code=MINUS;
    break;
  case '_'	:
    code=U_LINE;
    break;
  case '+'	:
    code=PLUS;
    break;
  case '('	:
    code=PARLEFT;
    break;
  case ')'	:
    code=PARRIGHT;
    break;
  case '['	:
    code=BRKLEFT;
    break;
  case ']'	:
    code=BRKRIGHT;
    break;
  case '<'	:
    code=LESSTHAN;
    break;
  case '>'	:
    code=GRTRTHAN;
    break;
  case '='	:
    code=PUNCT;
    if (numrow!=0) {
      if (lines[numline][numrow]=='?') {
        numrow++;
        code=DEBENCOD;
        }
      }
    break;
  case '?'	:
    code=QUESTION;
    if (numrow!=0) {
      if (lines[numline][numrow]=='=') {
        numrow++;
        code=ENCODFIN;
        }
      }
    break;
  default	:
    code=PUNCT;
    break;
  }
return code;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the token value 	*/
/*	from a string				*/
/*						*/
/************************************************/
static int tokenfromstr(char *strtoken,int *disp)

{
int token;
int i;

*disp=0;
token=WORD;
for (i=0;vocable[i].string!=(char *)0;i++) {
  *disp=strlen(vocable[i].string);
  if (strncasecmp(vocable[i].string,strtoken,*disp)==0) {
    token=vocable[i].code;
    break;
    }
  }
return token;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to backspace in the header	*/
/*	the data-header				*/
/*						*/
/************************************************/
static void backspace()

{
numline=curline;
numrow=currow;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get the next character from*/
/*	the data-header				*/
/*						*/
/************************************************/
static char getnextchar()

{
int c;

c=EOF;
if (lines[numline]!=(char *)0) {
  curline=numline;
  currow=numrow;
  if ((numrow==0)&&(debug>0)) {
    char *addstr;

    addstr="";
    if (strlen(lines[numline])>MXSTR)
      addstr="...";
    (void) clm_alert(9,"%6d line=<%.*s%s>",numline+1,MXSTR,lines[numline],addstr);
    }
  c=(int)lines[numline][numrow];
  if (c=='\000') {
    c='\n';
    numrow=0;
    numline++;
    }
  else
    numrow++;
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to synchronize on  a special	*/
/*	character within the line parsed line.	*/
/*						*/
/************************************************/
static int skipfor(char expected)

{
int found;

found=false;
while (lines[numline][numrow]!='\000') {
  if (lines[numline][numrow]==expected) {
    found=true;
    break;
    }
  numrow++;
  }
return found;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract a string on a line	*/
/*						*/
/************************************************/
static char *getstring()

{
#define STRINC  20

char c;
char *strloc;
int locnumline;
int locnumrow;

locnumline=numline;
locnumrow=numrow;
strloc=(char *)calloc(1,STRINC+5);
while ((c=getnextchar())!=EOF) {
  int bspace;
  char ajout[2];

  bspace=false;
  if ((strlen(strloc)%STRINC)==0) {
    strloc=(char *)realloc(strloc,(((strlen(strloc)/STRINC)+1)*STRINC)+5);
    }
  bspace=((strlen(strloc)>1)&&(strloc[strlen(strloc)]=='\\'));
  if ((c=='\n')&&(bspace==false)) {
    (void) free(strloc);
    strloc=(char *)0;
    numline=locnumline;
    numrow=locnumrow;
    break;
    }
  if ((c=='\"')&&(bspace==false))
    break;
  ajout[0]=c;
  (void) strncat(strloc,ajout,1);
  }
return strloc;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to skip comment in the header	*/
/*						*/
/************************************************/
static int skipcomment()

{
int c;
int proceed;

proceed=true;
c='(';
while (proceed==true) {
  proceed=false;
  c=getnextchar();
  if (c=='(')
    c=skipcomment(); 
  switch(c) {
    case ')'	:
      c=getnextchar();
      break;
    case '\n'	:
    case EOF	:
      (void) yyerror("')' expected ");
      break;
    default	:
      proceed=true;
      break;
    }
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to skip all blank character	*/
/*						*/
/************************************************/
static int skipblank()

{
int c;
int proceed;

c=EOF;
proceed=true;
while (proceed==true) {
  c=getnextchar();
  while (c=='(') {
    c=skipcomment();
    }
  if (isblank(c)==false)
    proceed=false;
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get/recognise a lexical	*/
/*	input.					*/
/*						*/
/************************************************/
static int yylex()

{
#define MXINFO	200

int found;
int c;
int proceed;
int phase;
int disp;
int numerique;
char info[MXINFO];

found=STOP;
phase=0;
proceed=true;
disp=0;
numerique=false;
(void) memset(info,'\000',sizeof(info));
c=skipblank();
if (c==EOF) {
  if (cptstop>0)
    (void) siglongjmp(manystop,1);
    cptstop++;
  return STOP;
  }
while (proceed==true) {
  switch (phase) {
    case     0	:	/*looking for strings	*/
      if (c=='\"') {
        if ((yylval.string=getstring())!=(char *)0) {
	  found=STRING;
	  proceed=false;
	  }
	}
      break;
    case     1	:	/* looking for punct	*/
      if (isalnum(c)==false) {
        found=punctchar(c);
	yylval.punct=(char)c;
	proceed=false;
	}
      break;
    case     2	:	/* looking for keyword	*/
      if ((found=tokenfromstr(lines[numline]+(numrow-1),&disp))!=WORD) {
	char *ptr;

	ptr=lines[numline]+(numrow-1)+disp;
	if (isalnum(*ptr)==false) {
	  numrow+=(disp-1);
	  proceed=false;
	  }
	}
      break;
    case     3	:	/*checking if word could be numeric	*/
      if (isdigit(c)!=false) 
	numerique=true;
      break;
    case     4	:	/*extracting word			*/
      {
      int extract;
      unsigned int inx;

      extract=true;
      inx=0;
      while (extract==true) {
        info[inx++]=c;
        if ((c=getnextchar())==EOF) {
          found=STOP;
	  if (cptstop>0)
	    (void) siglongjmp(manystop,1);
	  cptstop++;
	  extract=false;
	  break;
          }
        if (inx>=sizeof(info))
          extract=false;
        if (extract==false)
	  break;
        extract=((isalnum(c)!=false));
        if (numerique==true)
	  extract|=((c=='.')||(c=='-')||(c=='+'));
	}
      (void) backspace();
      }
      break;
    case     5	:	/* this an alphanumic word	*/
      yylval.word=strdup(info);
      found=WORD;
      proceed=false;
      break;
    default	:	/*safe guard			*/
      proceed=false;
      break;
    }
  phase++;
  }
#ifdef DEBUG
if (yydebug>0) {
  /*synchronizing yydebug output	*/
  (void) fflush(stdout);
  (void) fflush(stderr);
  }
#endif
(void) clm_alert(11,"return token (value='%d')",found);
return found;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free the memory used by	*/
/*	a HDRTYP ** structure			*/
/*						*/
/************************************************/
static HDRTYP **cleanhdr(HDRTYP **chdrs)

{
if (chdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;chdrs[i]!=(HDRTYP *)0;i++) {
    switch (chdrs[i]->field) {
      case (hd_from)		:
      case (hd_sender)		:
      case (hd_replyto)		:
      case (hd_msgid)		:
	chdrs[i]->info.address=clm_freestr(chdrs[i]->info.address);
	break;
      case (hd_cc)		:
      case (hd_bcc)		:
      case (hd_to)		:
      case (hd_inreplyto)	:
      case (hd_references)	:
        if (chdrs[i]->info.maddr!=(char **)0) {
	  int j;

	  for (j=0;chdrs[i]->info.maddr[j]!=(char *)0;j++) {
	    (void) free(chdrs[i]->info.maddr[j]);
	    }
          (void) free(chdrs[i]->info.maddr);
	  }
	break;
      case (hd_date)		:
	chdrs[i]->info.time=clm_freestr(chdrs[i]->info.time);
	break;
      case (hd_receive)		:
	chdrs[i]->info.receive=clm_freestr(chdrs[i]->info.receive);
	break;
      case (hd_subject)		:
	chdrs[i]->info.subject=clm_freestr(chdrs[i]->info.subject);
	break;
      default			:
        (void) clm_alert(0,"unievl.y,hdr_cleanhdr: Unexpected field (bug?)");
	break;
      }
    (void) free(chdrs[i]);
    }
  (void) free(chdrs);
  chdrs=(HDRTYP **)0;
  }
return chdrs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to trace the address part of	*/
/*	header contents				*/
/*						*/
/************************************************/
static void displayaddr(int lv,HDRTYP *hdr)

{
char *ptr;

switch(hdr->field) {
  case hd_to		:
    ptr="To";
    break;
  case hd_cc		:
    ptr="Cc";
    break;
  case hd_bcc		:
    ptr="Bcc";
    break;
  case hd_inreplyto	:
    ptr="In-Reply-To";
    break;
  case hd_references	:
    ptr="References";
    break;
  default		:
    ptr="(bug?)";
    break;
  }
if (hdr->info.maddr!=(char **)0) {
  int i;

  for (i=0;hdr->info.maddr[i]!=(char *)0;i++) 
    (void) clm_alert(lv,"E_%s: <%s>",ptr,hdr->info.maddr[i]);
  }
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to trace the wanted headers	*/
/*	contents, in the debug logs		*/
/*						*/
/************************************************/
static void tracehdr(int lv,HDRTYP **chdrs)

{
if (chdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;chdrs[i]!=(HDRTYP *)0;i++) {
    switch (chdrs[i]->field) {
      case (hd_from)		:
	(void) clm_alert(lv,"E_From: <%s>",chdrs[i]->info.address);
	break;
      case (hd_cc)		:
      case (hd_bcc)		:
      case (hd_to)		:
      case (hd_inreplyto)	:
      case (hd_references)	:
	(void) displayaddr(lv,chdrs[i]);
	break;
      case (hd_sender)		:
	(void) clm_alert(lv,"E_Sender: <%s>",chdrs[i]->info.address);
	break;
      case (hd_replyto)		:
	(void) clm_alert(lv,"E_Reply-To: <%s>",chdrs[i]->info.address);
	break;
      case (hd_msgid)		:
	(void) clm_alert(lv,"E_Message-ID: <%s>",chdrs[i]->info.address);
	break;
      case (hd_date)		:
	{
	char *ptr;
	time_t temps;

	temps=atol(chdrs[i]->info.time);	
	ptr=asctime(gmtime(&temps));
	ptr[strlen(ptr)-1]='\000';
	(void) clm_alert(lv,"E_Date: <%s>",ptr);
	}
	break;
      case (hd_receive)		:
	if (chdrs[i]->info.receive!=(char *)0) {/*always*/
	  char *addstr;

	  addstr="";
	  if (strlen(chdrs[i]->info.receive)>MXSTR)
	    addstr="...";
	  (void) clm_alert(lv,"E_Receive: <%.*s%s>",MXSTR,chdrs[i]->info.receive,addstr);
	  }
	break;
      case (hd_subject)		:
	(void) clm_alert(lv,"E_Subject: <%s>",chdrs[i]->info.subject);
	break;
      default			:
        (void) clm_alert(0,"unievl.c,evl_tracehdr: Unexpected field (bug?)");
	break;
      }
    }
  }
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to scan a header and locate	*/
/*	specific information			*/
/*						*/
/************************************************/
static HDRTYP **parsehdrs(char **data)

{
HDRTYP **hdrs;
int verybad;

verybad=false;
cptstop=0;
lines=data;
numline=0;
numrow=0;
itsok=true;
nbrerr=0;
#ifdef DEBUG
if (debug>11)	/*debugging all yacc analyze	*/
  yydebug=1;
#endif
if (sigsetjmp(manystop,true)==0)
  verybad=yyparse(); 
else {
  verybad=true;
  }
hdrs=yhdrs;
yhdrs=(HDRTYP **)0;
(void) cleanyyparse();
if (verybad==true)
  hdrs=cleanhdr(hdrs); 
return hdrs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to scan a header and remove	*/
/*	to be trashed memory if needed.		*/
/*						*/
/************************************************/
static HDRTYP **mkhdr(char **data)

{
#define	OPMK	"geshdr.y.c:mkhdr,"

HDRTYP **hdrs;
GACTYP *gat;
int phase;
int proceed;

hdrs=(HDRTYP **)0;
gat=(GACTYP *)0;
phase=0;
proceed=true;
while (proceed==true) {
  switch (phase) {
    case 0	:	/*open Garbage Collector*/
      if ((gat=gac_open(0,appname,"parsing_email_header"))==(GACTYP *)0) {
	(void) clm_alert(0,"%s Unable to open garbage collector (errno=<%s> bug?)",
			   OPMK,strerror(errno));
	phase=999;	/*big trouble		*/
	}
      break;
    case 1	:	/*parsing under GC	*/
      if ((hdrs=parsehdrs(data))==(HDRTYP **)0)
	phase++;	/*no need duplicat	*/
      break;
    case 2	:	/*dup hdrs without GC	*/
      if (hdrs!=(HDRTYP **)0)	{/*always	*/
        long remaining;
	HDRTYP **clone;
	int i;

	(void) gac_gear(gear_down,&remaining);
	clone=(HDRTYP **)0;
  	for (i=0;hdrs[i]!=(HDRTYP *)0;i++) {
    	  HDRTYP *loc;

    	  loc=dupheader(hdrs[i]->field,hdrs[i]->info.info);
          clone=(HDRTYP **)vec_addlstlst((void **)clone,(void *)loc);
	  }
        (void) gac_gear(gear_up,&remaining);
  	hdrs=cleanhdr(hdrs); 
  	hdrs=clone; 
    	}
      break;
    case 3	:	/*cleaning trash	*/
      (void) clm_trashmem(1,gat);
      break;
    default	:	/*SAFE Guard		*/
      proceed=false;
      break;
    }
  phase++;
  }
return hdrs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract ALL reference found*/
/*	available in the E-mail header.		*/
/*						*/
/************************************************/
static char **getallhdrinfo(HDRTYP **hdrs,HIDTYP field)

{
char **infos;

infos=(char **)0;
if (hdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;hdrs[i]!=(HDRTYP *)0;i++) {
    if (hdrs[i]->field==field) {
      switch (field) {
        case (hd_receive)	:
	  infos=(char **)vec_addlstlst((void **)infos,(void *)hdrs[i]->info.receive);
	  break;
  	default			:
    	  (void) clm_alert(0,"geshdr.y:getallhdrinfo, Unexpected field (bug?)");
	  break;
	}
      }
    }
  }
return infos;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract a reference found	*/
/*	available in the E-mail header.		*/
/*						*/
/************************************************/
static void *gethdrinfo(HDRTYP **hdrs,HIDTYP field)

{
void *str;

str=(char *)0;
if (hdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;hdrs[i]!=(HDRTYP *)0;i++) {
    if (hdrs[i]->field==field) {
      switch (field) {
        case (hd_from)		:
        case (hd_sender)	:
        case (hd_replyto)	:
        case (hd_msgid)		:
          str=(void *)hdrs[i]->info.address;
	  break;
  	case (hd_date)		:
          str=(void *)hdrs[i]->info.time;
	  break;
  	case (hd_inreplyto)	:
  	case (hd_references)	:
          str=(void *)hdrs[i]->info.maddr;
	  break;
  	case (hd_to)		:
  	case (hd_cc)		:
  	case (hd_bcc)		:
          str=(void *)hdrs[i]->info.maddr;
	  break;
        case (hd_subject)	:
          str=(void *)hdrs[i]->info.subject;
	  break;
  	default			:
    	  (void) clm_alert(0,"geshdr.y:getallhdrinfo, Unexpected field (bug?)");
	  break;
	}
      break;
      }
    }
  }
return str;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to collect specific set of	*/
/*	headers.				*/
/*						*/
/************************************************/
static char **mklist(HDRTYP **hdrs,char **list,HIDTYP hid)

{
char **mptr;

if ((mptr=gethdrinfo(hdrs,hid))!=(char **)0) {
  int i;

  for (i=0;mptr[i]!=(char *)0;i++) {
    list=(char **)vec_addlstlst((void **)list,(void *)strdup(mptr[i]));
    }
  }
return list;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to normalize some E-mails	*/
/*	(generated by mailling list) such	*/
/*	address x.12.34@somewhere.com		*/
/*	is translated to x@somewhwere.com	*/
/*						*/
/************************************************/
static char *cleanreal(char *real)

{
if (real!=(char *)0) {
  char *ptr;

  if ((ptr=strchr(real,'.'))!=(char *)0) {
    char *dotptr;
    int skip;
    int proceed;

    dotptr=ptr;
    ptr++;
    skip=true;
    proceed=true;
    while (proceed==true) {
      switch (*ptr) {
        case '@'  	:
        case '\000'  	:
	  proceed=false;	/*do NOT break	*/
        case '.'	:
	  if (skip==true) {
	    (void) strcpy(dotptr,ptr);
	    ptr=dotptr;
	    }
	  dotptr=ptr;
	  skip=true;
	  break;
	default		:
	  if (skip==true)
	    skip=(isdigit(*ptr)!=false);
	  break;
        }
      ptr++;
      }
    }
  }
return real;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to look at E-mail header	*/
/*	information and extract selected fields	*/
/*						*/
/************************************************/
static EVLTYP *lookhdrs(char *session,HDRTYP **hdrs)

{
EVLTYP *evl;
int phase;
int proceed;

evl=(EVLTYP *)calloc(1,sizeof(EVLTYP));
phase=0;
proceed=true;
while (proceed==true) {
  char *ptr;

  ptr=(char *)0;
  switch (phase) {
    case	 0  :	/*extracting "Sender"	*/
      if ((ptr=gethdrinfo(hdrs,hd_sender))!=(char *)0) {
	evl->org=org_sender;
        evl->realfrom=strdup(ptr);
	phase++;	/*getting MSG DATE	*/
	phase++;
        }
      break;
    case	 1  :	/*extracting "Reply-To"	*/
      if ((ptr=gethdrinfo(hdrs,hd_replyto))!=(char *)0) {
	evl->org=org_replyto;
        evl->realfrom=strdup(ptr);
	phase++;	/*getting MSG DATE	*/
        }
      break;
    case	 2  :	/*extracting "From"	*/
      if ((ptr=gethdrinfo(hdrs,hd_from))!=(char *)0) {
	evl->org=org_from;
        evl->realfrom=strdup(ptr);
        }
      break;
    case	 3  :	/*extracting MSG date	*/
      if ((ptr=gethdrinfo(hdrs,hd_date))!=(char *)0) {
        evl->cachet=(time_t)atol(ptr);
        }
      break;
    case	 4  :	/*extracting MSGID	*/
      if ((ptr=gethdrinfo(hdrs,hd_msgid))!=(char *)0) 
      	evl->msgid=strdup(ptr);
      else
        (void) asprintf(&(evl->msgid),"%s@empty.msgid",session);
      evl->msgid=clm_cleanstring(evl->msgid); 
      break;
    case	 5  :	/*extracting Subject	*/
      if ((ptr=gethdrinfo(hdrs,hd_subject))==(char *)0) 
	ptr="___UNSPECIFIED____";
      evl->subject=strdup(ptr);
      evl->subject=clm_cleanstring(evl->subject); 
      if (strlen(evl->subject)==0) {
  	(void) free(evl->subject);
	evl->subject=strdup("___EMPTY____");
	}
      break;
    case	 6  :	/*extracting In-Reply-To*/
      evl->inrplyto=mklist(hdrs,(char **)0,hd_inreplyto);
      evl->inrplyto=mklist(hdrs,evl->inrplyto,hd_references);
      break;
    case	 7  :	/*extracting To,Cc,Bcc	*/
      evl->distlist=mklist(hdrs,(char **)0,hd_to);
      evl->distlist=mklist(hdrs,evl->distlist,hd_cc);
      evl->distlist=mklist(hdrs,evl->distlist,hd_bcc);
      break;
    case	8  :	/*cleaning realfrom	*/
      evl->realfrom=cleanreal(evl->realfrom); 
      break;
    case	9  :	/*counting received	*/
      if (hdrs!=(HDRTYP **)0) { /*always	*/
	char **infos;

        if ((infos=getallhdrinfo(hdrs,hd_receive))!=(char **)0) {
	  register int i;
  
	  for (i=0;infos[i]!=(char *)0;i++);
	  evl->nbrreceived=i;
	  (void) free(infos);
	  }
	}
      break;
    default	    :	/*SAFE Guard		*/
      proceed=false;
      break;
    }
  phase++;
  }
return evl;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to build a E-mail header	*/
/*	list, by concatanating lines which start*/
/*	with a space (see RFC 2022)		*/
/*						*/
/************************************************/
char **mkyachdr(char **headers)

{
char **yachdr;

yachdr=(char **)0;
if (headers!=(char **)0) {
  int i;

  for (i=0;headers[i]!=(char *)0;i++) {
    char *ptr;

    ptr=strdup(headers[i]);
    while (headers[i+1]!=(char *)0) {
      if (isblank(headers[i+1][0])==0) {
	break;
	}
      i++;
      headers[i][0]=' '; /*to get rid of TAB	*/
      ptr=(char *)realloc(ptr,strlen(ptr)+strlen(headers[i])+4);
      (void) strcat(ptr,headers[i]);
      }
    yachdr=(char **)vec_addlstlst((void **)yachdr,(void *)ptr);
    }
  }
return yachdr;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to analyse the email header	*/
/*	part. looking for information as:	*/
/*	Sender:, Reply-To:, From:...		*/
/*						*/
/************************************************/
EVLTYP *hdr_parseheader(char *session,char **headers)

{
EVLTYP *evl;

evl=(EVLTYP *)0;
if (headers!=(char **)0) {
  HDRTYP **hdrs;
  char **yachdr;

  yachdr=mkyachdr(headers);
  if ((hdrs=mkhdr(yachdr))!=(HDRTYP **)0) {
    evl=lookhdrs(session,hdrs);
    evl->nbrerror=nbrerr;
    if (debug>=2)
      (void) tracehdr(2,hdrs);
    hdrs=cleanhdr(hdrs);
    }
  else {
    int i;

    (void) clm_alert(0,"%s fatal header parsing error (session=<%s>",
		       "geshdr.y:hdr_parsehdr,",session);
    for (i=0;headers[i]!=(char *)0;i++) {
      (void) clm_alert(0,"header[%d]=<%s>",i,headers[i]);
      }
    }
  (void) vec_freelstlst((void **)yachdr,VECFREE);
  }
return evl;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free memory used by an	*/
/*	E-mail info structure			*/
/*						*/
/************************************************/
EVLTYP *hdr_freeevl(EVLTYP *evl)

{
if (evl!=(EVLTYP *)0) {
  evl->spamlvl=clm_freestr(evl->spamlvl);
  evl->distlist=(char **)vec_freelstlst((void **)evl->distlist,VECFREE);
  evl->inrplyto=(char **)vec_freelstlst((void **)evl->inrplyto,VECFREE);
  evl->virname=clm_freestr(evl->virname);
  evl->subject=clm_freestr(evl->subject);
  evl->msgid=clm_freestr(evl->msgid);
  evl->realfrom=clm_freestr(evl->realfrom);
  (void) free(evl);
  evl=(EVLTYP *)0;
  }
return evl;
}


#line 1986 "geshdr.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 288 "geshdr.y"
{
			yhdrs=yyvsp[-1].hdrs;
                        if (itsok==true)
                          YYACCEPT;
                        else
                          YYABORT;
			}
break;
case 2:
#line 296 "geshdr.y"
{
			YYABORT;
			}
break;
case 3:
#line 302 "geshdr.y"
{
			yyval.hdrs=addhdrs((HDRTYP **)0,yyvsp[0].header);
			yhdrs=yyval.hdrs;
			}
break;
case 4:
#line 307 "geshdr.y"
{
			yyval.hdrs=addhdrs(yyvsp[-1].hdrs,yyvsp[0].header);
			yhdrs=yyval.hdrs;
			}
break;
case 5:
#line 314 "geshdr.y"
{
			yyval.header=yyvsp[-1].header;
			}
break;
case 6:
#line 320 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 7:
#line 324 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 8:
#line 328 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 9:
#line 332 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 10:
#line 336 "geshdr.y"
{
			(void) free(yyvsp[0].word);
			yyval.header=(HDRTYP *)0;
			if (numrow>0)
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			}
break;
case 11:
#line 344 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (numrow>0)
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			(void) clm_alert(2,"header error!");
			}
break;
case 12:
#line 354 "geshdr.y"
{
			if (yyvsp[0].word!=(char *)0)
			  (void) free(yyvsp[0].word);
			}
break;
case 16:
#line 369 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].email!=(char *)0) {
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			  }
			}
break;
case 17:
#line 378 "geshdr.y"
{
			yyval.integer=(int)hd_from;
			}
break;
case 18:
#line 382 "geshdr.y"
{
			yyval.integer=(int)hd_sender;
			}
break;
case 19:
#line 386 "geshdr.y"
{
			yyval.integer=(int)hd_replyto;
			}
break;
case 20:
#line 392 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxs!=(char **)0) 
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 21:
#line 398 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxs!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 22:
#line 406 "geshdr.y"
{
			yyval.integer=(int)hd_to;
			}
break;
case 23:
#line 410 "geshdr.y"
{
			yyval.integer=(int)hd_cc;
			}
break;
case 24:
#line 416 "geshdr.y"
{
			yyval.integer=(int)hd_bcc;
			}
break;
case 25:
#line 422 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxs!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 26:
#line 428 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxs!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 27:
#line 434 "geshdr.y"
{
			char *ptr;

			yyval.header=(HDRTYP *)0;
			ptr=strdup(&(lines[numline][numrow]));
			(void) clm_skipblank(ptr);
			yyval.header=genheader((int)hd_receive,(void *)ptr);
			if (lines[numline]!=(char *)0) {
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			  }
			}
break;
case 28:
#line 447 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxs!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 29:
#line 453 "geshdr.y"
{
			#define MXSUB	150

			char *ptr;

			ptr=clm_skipblank(&(lines[numline][numrow]));
			ptr=cnv_mimequoted(ptr);
			if (strlen(ptr)>=MXSUB)
			  ptr[MXSUB-1]='\000';
			yyval.header=genheader((int)hd_subject,(void *)ptr);
			if (lines[numline]!=(char *)0) {
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			  }
			}
break;
case 30:
#line 472 "geshdr.y"
{
			yyval.integer=(int)hd_msgid;
			}
break;
case 31:
#line 478 "geshdr.y"
{
			yyval.integer=(int)hd_inreplyto;
			}
break;
case 32:
#line 484 "geshdr.y"
{
			yyval.integer=(int)hd_references;
			}
break;
case 33:
#line 490 "geshdr.y"
{
			yyval.mboxs=yyvsp[0].mboxs;
			}
break;
case 34:
#line 494 "geshdr.y"
{
			yyval.mboxs=(char **)0;
			}
break;
case 35:
#line 500 "geshdr.y"
{
			yyval.mboxs=(char **)0;
			if (yyvsp[0].email!=(char *)0)
  			  yyval.mboxs=(char **)vec_addlstlst((void **)0,
						            (void *)yyvsp[0].email);
			}
break;
case 36:
#line 507 "geshdr.y"
{
			yyval.mboxs=yyvsp[-1].mboxs;
			if (yyvsp[0].email!=(char *)0)
  			  yyval.mboxs=(char **)vec_addlstlst((void **)yyvsp[-1].mboxs,
						            (void *)yyvsp[0].email);
			}
break;
case 37:
#line 516 "geshdr.y"
{
			yyval.email=yyvsp[-1].email;
			(void) skipfor('<');
			}
break;
case 38:
#line 521 "geshdr.y"
{
			if (yyvsp[-1].email!=(char *)0) {
			  (void) free(yyvsp[-1].email);
			  yyvsp[-1].email=(char *)0;
			  }
			yyval.email=yyvsp[-1].email;
			(void) skipfor('<');
			}
break;
case 39:
#line 530 "geshdr.y"
{
			yyval.email=(char *)0;
			(void) skipfor('<');
			}
break;
case 40:
#line 535 "geshdr.y"
{
			if (yyvsp[0].word!=(char *)0)
			  (void) free(yyvsp[0].word);
			yyval.email=(char *)0;
			(void) skipfor('<');
			}
break;
case 41:
#line 542 "geshdr.y"
{
			if (yyvsp[0].word!=(char *)0)
			  (void) free(yyvsp[0].word);
			yyval.email=(char *)0;
			(void) skipfor('<');
			}
break;
case 42:
#line 557 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 43:
#line 561 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 44:
#line 567 "geshdr.y"
{
			yyval.header=genheader(hd_date,yyvsp[0].strtime);
			}
break;
case 45:
#line 574 "geshdr.y"
{
			yyval.header=genheader(hd_date,yyvsp[0].strtime);
			}
break;
case 46:
#line 580 "geshdr.y"
{
			yyval.strtime=yyvsp[0].strtime;
			}
break;
case 47:
#line 584 "geshdr.y"
{
			yyval.strtime=yyvsp[0].strtime;
			}
break;
case 48:
#line 590 "geshdr.y"
{
		        yyvsp[-1].integer+=yyvsp[0].integer;
			(void) asprintf(&(yyval.strtime),"%ld",yyvsp[-1].integer);
			}
break;
case 49:
#line 595 "geshdr.y"
{
			(void) asprintf(&(yyval.strtime),"%ld",yyvsp[0].integer);
			}
break;
case 50:
#line 601 "geshdr.y"
{
			struct tm timing;

			(void) memset(&timing,'\000',sizeof(timing));
			timing.tm_mday=yyvsp[-2].integer;
			timing.tm_mon=yyvsp[-1].integer;
	 		if (yyvsp[0].integer<100)
			  yyvsp[0].integer+=2000;
			timing.tm_year=yyvsp[0].integer-1900;
			yyval.time=timegm(&timing);
			}
break;
case 51:
#line 615 "geshdr.y"
{
			yyval.time=yyvsp[-1].time-yyvsp[0].time;
			}
break;
case 52:
#line 619 "geshdr.y"
{
			yyval.time=yyvsp[0].time;
			}
break;
case 53:
#line 623 "geshdr.y"
{
			yyval.time=-yyvsp[0].time;
			}
break;
case 54:
#line 629 "geshdr.y"
{
			yyval.time=(((yyvsp[-4].time*60)+(yyvsp[-2].time))*60)+yyvsp[0].time;
			}
break;
case 55:
#line 633 "geshdr.y"
{
			yyval.time=((yyvsp[-2].time*60)+(yyvsp[0].time))*60;
			}
break;
case 56:
#line 639 "geshdr.y"
{
			yyval.time=yyvsp[0].integer;
			if (yyvsp[0].integer>24) {
			  (void) yyerror("Unexpected value (above 24 Hour)");
			  yyval.time=0;
			  } 
			}
break;
case 57:
#line 649 "geshdr.y"
{
			yyval.time=yyvsp[0].integer;
			if (yyvsp[0].integer>60) {
			  (void) yyerror("Unexpected value (above 60)");
			  yyval.time=0;
			  } 
			}
break;
case 58:
#line 659 "geshdr.y"
{
			yyval.time=((yyvsp[-1].integer/100)*3600)+((yyvsp[-1].integer%100)*60);
			yyval.time*=yyvsp[-2].integer;
			}
break;
case 59:
#line 664 "geshdr.y"
{
			static struct {
				char *zname;
				int diff;
				}tznom[]={
					  {"UTC",-0},
					  {"Z",-0},
					  {"GMT",-0},
					  {"EST",-5},
					  {"EDT",-4},
					  {"CST",-6},
					  {"CDT",-5},
					  {"MST",-7},
					  {"MDT",-6},
					  {"PST",-8},
					  {"PDT",-7},
					  {"AKST",-9},
					  {"AKDT",-8},
					  {"HST",-10},
					  {"HST",-10},
					  {"BST",+1},
					  {"CET",+1},
					  {"CST",+2},
					  {(char *)0,0}
					  };
			int i;

			yyval.time=0;
			for (i=0;tznom[i].zname!=(char *)0;i++) {
			  if (strcasecmp(tznom[i].zname,yyvsp[0].word)==0) {
			    yyval.time=tznom[i].diff*3600;
			    break;
			    }
			  }	
			(void) free(yyvsp[0].word);
			}
break;
case 64:
#line 712 "geshdr.y"
{
			(void) free(yyvsp[0].word);
			}
break;
case 66:
#line 724 "geshdr.y"
{
			yyval.mboxs=yyvsp[0].mboxs;
			}
break;
case 67:
#line 728 "geshdr.y"
{
			yyval.mboxs=yyvsp[0].mboxs;
			}
break;
case 68:
#line 732 "geshdr.y"
{
			yyval.mboxs=(char **)0;
			}
break;
case 69:
#line 738 "geshdr.y"
{
			if (yyvsp[-3].word!=(char *)0)
			  (void) free(yyvsp[-3].word);
			yyval.mboxs=yyvsp[-1].mboxs;
			}
break;
case 70:
#line 744 "geshdr.y"
{
			if (yyvsp[-2].word!=(char *)0)
			  (void) free(yyvsp[-2].word);
			yyval.mboxs=(char **)0;
			}
break;
case 71:
#line 750 "geshdr.y"
{
			if (yyvsp[-2].word!=(char *)0)
			  (void) free(yyvsp[-2].word);
			yyval.mboxs=yyvsp[0].mboxs;
			}
break;
case 72:
#line 758 "geshdr.y"
{
			yyval.mboxs=(char **)0;
			if (yyvsp[0].email!=(char *)0) {
  			  yyval.mboxs=(char **)vec_addlstlst((void **)0,
						            (void *)yyvsp[0].email);
			  }
			}
break;
case 73:
#line 766 "geshdr.y"
{
			yyval.mboxs=yyvsp[-2].mboxs;
			if (yyvsp[-2].email!=(char *)0) {
  			  yyval.mboxs=(char **)vec_addlstlst((void **)yyvsp[-2].mboxs,
						            (void *)yyvsp[0].email);
			  }
			}
break;
case 74:
#line 776 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 75:
#line 780 "geshdr.y"
{
			if (yyvsp[-1].email!=(char *)0)
			  (void) free(yyvsp[-1].email);
			yyval.email=yyvsp[0].email;
			}
break;
case 76:
#line 786 "geshdr.y"
{
			/*trapping common syntax error	*/
			yyval.email=yyvsp[0].email;
			}
break;
case 77:
#line 791 "geshdr.y"
{
			/*trapping common syntax error	*/
			if (yyvsp[0].email!=(char *)0)
			  (void) free(yyvsp[0].email);
			yyval.email=yyvsp[-1].email;
			}
break;
case 78:
#line 798 "geshdr.y"
{
			if (yyvsp[-2].email!=(char *)0)
			  (void) free(yyvsp[-2].email);
			yyval.email=yyvsp[0].email;
			}
break;
case 79:
#line 804 "geshdr.y"
{
			if (yyvsp[-1].email!=(char *)0)
			  (void) free(yyvsp[-1].email);
			yyval.email=yyvsp[0].email;
			}
break;
case 80:
#line 810 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 81:
#line 817 "geshdr.y"
{
			char *strloc;

			strloc=strmix(yyvsp[-2].email,'@',yyvsp[0].email);
			yyval.email=strloc;
			}
break;
case 82:
#line 825 "geshdr.y"
{
			if (yyvsp[-1].word!=(char *)0)
			  (void) free(yyvsp[-1].word);
			yyval.word=(char *)0;
			}
break;
case 83:
#line 831 "geshdr.y"
{
			yyval.email=yyvsp[-2].email;
			}
break;
case 84:
#line 837 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 85:
#line 841 "geshdr.y"
{
			yyval.email=strmix(yyvsp[-2].email,'.',yyvsp[0].word);
			}
break;
case 86:
#line 860 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 87:
#line 864 "geshdr.y"
{
			yyval.email=strmix(yyvsp[-1].email,'\000',yyvsp[0].word);
			}
break;
case 88:
#line 870 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 89:
#line 874 "geshdr.y"
{
			yyval.email=strmix(yyvsp[-2].email,'.',yyvsp[0].email);
			}
break;
case 90:
#line 878 "geshdr.y"
{
			yyval.email=yyvsp[-2].email;
			}
break;
case 91:
#line 884 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 92:
#line 888 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 93:
#line 894 "geshdr.y"
{
			yyval.email=yyvsp[0].word;
			}
break;
case 94:
#line 898 "geshdr.y"
{
			yyval.email=strmix(yyvsp[-1].email,'\000',yyvsp[0].word);
			}
break;
case 95:
#line 902 "geshdr.y"
{
			(void) yyerror("Unexpected character after domain reference");
			yyval.email=yyvsp[-1].word;
			}
break;
case 96:
#line 907 "geshdr.y"
{
			(void) yyerror("Unexpected string after domain reference");
			yyvsp[0].word=clm_freestr(yyvsp[0].word);
			yyval.email=yyvsp[-1].word;
			}
break;
case 97:
#line 915 "geshdr.y"
{
			yyval.email=(char *)0;
			if (yyvsp[-1].word!=(char *)0) {
			  (void) asprintf(&(yyval.email),"[%s]",yyvsp[-1].word);
			  (void) free(yyvsp[-1].word);
			  }
			}
break;
case 98:
#line 923 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 99:
#line 929 "geshdr.y"
{
			char *ptr;

			ptr=strdup(&(lines[numline][numrow]));
			yyval.email=ptr;
			while (*ptr!='\000') {
			  switch (*ptr) {
			    case ']'	:
			    case '['	:
			      *ptr='\000';
			      *(ptr+1)='\000';
			      break;
			    default	:
			      break;
			    }
			  ptr++;
			  }
			(void) skipfor(']');
			}
break;
case 100:
#line 951 "geshdr.y"
{
			yyval.email=yyvsp[-1].email;
			}
break;
case 101:
#line 955 "geshdr.y"
{
			yyval.email=yyvsp[-1].email;
			}
break;
case 102:
#line 959 "geshdr.y"
{
			yyval.email=(char *)0;
			}
break;
case 103:
#line 963 "geshdr.y"
{
			if (yyvsp[-1].word!=(char *)0)
			  (void) free(yyvsp[-1].word);
			nbrerr++;
			yyval.email=(char *)0;
			}
break;
case 104:
#line 970 "geshdr.y"
{
			yyval.email=(char *)0;
			}
break;
case 105:
#line 976 "geshdr.y"
{
			if (yyvsp[-1].email!=(char *)0)
			  (void) free(yyvsp[-1].word);
			}
break;
case 106:
#line 986 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 107:
#line 990 "geshdr.y"
{
			yyval.word=strmix(yyvsp[-1].word,'\000',yyvsp[0].word);
			}
break;
case 108:
#line 994 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 109:
#line 1009 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 110:
#line 1013 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 111:
#line 1019 "geshdr.y"
{	/*WAITING for end of encoding	*/
			int phase;
			int proceed;

			phase=0;
			proceed=true;
			while (skipfor('?')==true) {
			  switch (phase) {
			    case 0  :
			    case 1  :
			      phase++;
			      break;
			    case 2  :
			      if (lines[numline][numrow+1]!='=') {
			        nbrerr++;
			        (void) yyerror("Encoding syntax error");
				}
			      proceed=false;
			      break;
			    }
			  if (proceed==true)
			    numrow+=1;
			  else
			    break;
			  }
			}
break;
case 112:
#line 1046 "geshdr.y"
{
			yyval.word=(char *)0;
			}
break;
case 113:
#line 1052 "geshdr.y"
{
			char *ptr;

			ptr=yyvsp[0].word;
			yyval.integer=0;
        		if (strchr(ptr,'.')==(char *)0) {
			  long lval;

          		  if (sscanf(ptr,"%ld",&lval)==1) {
            		    yyval.integer=lval;
            		    }
          		  }
        		else {
			  (void) yyerror("Integer expected, found float");
			  }
			(void) free(yyvsp[0].word);
			}
break;
case 114:
#line 1072 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 115:
#line 1076 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 116:
#line 1083 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 117:
#line 1087 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 118:
#line 1091 "geshdr.y"
{
		        static char *daylist[]={
		   		"Sun","Mon","Tue","Wed","Thu",
		   		"Fri","Sat"};
			yyval.word=strdup(daylist[yyvsp[0].integer]);
			}
break;
case 119:
#line 1098 "geshdr.y"
{
		        static char *monthlist[]={
				"Jan","Feb","Mar","Apr",
				"May","Jun","Jul","Aug",
		   		"Sep","Oct","Nov","Dec"};
			yyval.word=strdup(monthlist[yyvsp[0].integer]);
			}
break;
case 120:
#line 1108 "geshdr.y"
{
			char strloc[10];

			(void) memset(strloc,'\000',sizeof(strloc));
			strloc[0]=yyvsp[0].punct;
			yyval.word=strdup(strloc);
			}
break;
case 121:
#line 1116 "geshdr.y"
{
			yyval.word=strdup("-");
			}
break;
case 122:
#line 1120 "geshdr.y"
{
			yyval.word=strdup("+");
			}
break;
case 123:
#line 1124 "geshdr.y"
{
			yyval.word=strdup("?");
			}
break;
case 124:
#line 1128 "geshdr.y"
{
			yyval.word=strdup("_");
			}
break;
case 125:
#line 1134 "geshdr.y"
{
			yyval.word=strdup("Date");
			}
break;
case 126:
#line 1138 "geshdr.y"
{
			yyval.word=strdup("To");
			}
break;
case 127:
#line 1142 "geshdr.y"
{
			yyval.word=strdup("Cc");
			}
break;
case 128:
#line 1146 "geshdr.y"
{
			yyval.word=strdup("Bcc");
			}
break;
case 129:
#line 1150 "geshdr.y"
{
			yyval.word=strdup("From");
			}
break;
case 130:
#line 1154 "geshdr.y"
{
			yyval.word=strdup("Sender");
			}
break;
case 131:
#line 1158 "geshdr.y"
{
			yyval.word=strdup("Reply-To");
			}
break;
case 132:
#line 1164 "geshdr.y"
{
			yyval.integer=0;
			}
break;
case 133:
#line 1168 "geshdr.y"
{
			yyval.integer=1;
			}
break;
case 134:
#line 1172 "geshdr.y"
{
			yyval.integer=2;
			}
break;
case 135:
#line 1176 "geshdr.y"
{
			yyval.integer=3;
			}
break;
case 136:
#line 1180 "geshdr.y"
{
			yyval.integer=4;
			}
break;
case 137:
#line 1184 "geshdr.y"
{
			yyval.integer=5;
			}
break;
case 138:
#line 1188 "geshdr.y"
{
			yyval.integer=6;
			}
break;
case 139:
#line 1192 "geshdr.y"
{
			yyval.integer=7;
			}
break;
case 140:
#line 1196 "geshdr.y"
{
			yyval.integer=8;
			}
break;
case 141:
#line 1200 "geshdr.y"
{
			yyval.integer=9;
			}
break;
case 142:
#line 1204 "geshdr.y"
{
			yyval.integer=10;
			}
break;
case 143:
#line 1208 "geshdr.y"
{
			yyval.integer=11;
			}
break;
case 144:
#line 1214 "geshdr.y"
{
			yyval.integer=0;
			}
break;
case 145:
#line 1218 "geshdr.y"
{
			yyval.integer=1;
			}
break;
case 146:
#line 1222 "geshdr.y"
{
			yyval.integer=2;
			}
break;
case 147:
#line 1226 "geshdr.y"
{
			yyval.integer=3;
			}
break;
case 148:
#line 1230 "geshdr.y"
{
			yyval.integer=4;
			}
break;
case 149:
#line 1234 "geshdr.y"
{
			yyval.integer=5;
			}
break;
case 150:
#line 1238 "geshdr.y"
{
			yyval.integer=6;
			}
break;
case 151:
#line 1244 "geshdr.y"
{
			yyval.integer=-1;
			}
break;
case 152:
#line 1248 "geshdr.y"
{
			yyval.integer=+1;
			}
break;
case 153:
#line 1252 "geshdr.y"
{
			yyval.integer=+1;
			}
break;
#line 3274 "geshdr.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
