#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define yyparse gestruparse
#define yylex gestrulex
#define yyerror gestruerror
#define yychar gestruchar
#define yyval gestruval
#define yylval gestrulval
#define yydebug gestrudebug
#define yynerrs gestrunerrs
#define yyerrflag gestruerrflag
#define yyss gestruss
#define yyssp gestrussp
#define yyvs gestruvs
#define yyvsp gestruvsp
#define yylhs gestrulhs
#define yylen gestrulen
#define yydefred gestrudefred
#define yydgoto gestrudgoto
#define yysindex gestrusindex
#define yyrindex gestrurindex
#define yygindex gestrugindex
#define yytable gestrutable
#define yycheck gestrucheck
#define yyname gestruname
#define yyrule gestrurule
#define yysslim gestrusslim
#define yystacksize gestrustacksize
#define YYPREFIX "gestru"
#line 8 "gestru.y"
/*force le debugging du YACC                    */
#define lint    1
#ifdef	DEBUG
#define YYDEBUG 1
#endif

#include	<string.h>
#include	<stdio.h>
#include	<setjmp.h>
#include	<syslog.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<time.h>
#include	<ctype.h>

#include	"lowtyp.h"
#include	"utlgac.h"
#include	"utlvec.h"
#include	"bascnv.h"
#include	"subclm.h"
#include	"unieml.h"
#include	"gestru.h"

int yyparse();		/*syntax parser		*/
static int yylex();	/*lexical parser	*/

/*preamble static function declaration		*/
static void yyerror(char *);

static STRMTY **ystrms;	/*yacc stream info	*/
static int itsok;	/*parsing status	*/
static jmp_buf manystop;/*YACC fully lost	*/
static int cptstop=0;	/*stop received counting*/
static char *ykeyword;	/*ref to current kword	*/

static char **lines;	/*data-header pointer	*/
static int numline;	/*next char header line	*/
static int numrow;	/*next char header row	*/
static int curline;	/*cur char header line	*/
static u_int currow;	/*cur char header row	*/
static int nbrerr;	/*number of error so far*/
static int lastcode;	/*last code retreived	*/

#define	MXSTR	60	/*max line size in debug*/
#define STRIPV6	"ipv6"	/*Ipv6 ip marker	*/
/*

*/
/************************************************/
/*						*/
/*	Procedure to duplicate  DLGTYPstructure	*/
/*						*/
/************************************************/
static DLGTYP **dupdlgs(DLGTYP **dlgs)

{
DLGTYP **ndlgs;

ndlgs=(DLGTYP **)0;
if (dlgs!=(DLGTYP **)0) {
  DLGTYP **ptr;

  for (ptr=dlgs;(*ptr)!=(DLGTYP *)0;ptr++) {
    DLGTYP *ndlg;

    if ((ndlg=tru_dupdlg(*ptr))!=(DLGTYP *)0) 
      ndlgs=(DLGTYP **)vec_addlstlst((void **)ndlgs,(void *)ndlg);
    }
  }
return ndlgs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free memory used by DLGTYP	*/
/*	structure.				*/
/*						*/
/************************************************/
static DLGTYP **freedlgs(DLGTYP **dlgs)

{
if (dlgs!=(DLGTYP **)0) {
  int i;

  for (i=0;dlgs[i]!=(DLGTYP *)0;i++) 
    dlgs[i]=tru_freedlg(dlgs[i]);
  (void) free(dlgs);
  dlgs=(DLGTYP **)0;
  }
return dlgs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free memory used by streams*/
/*	structure.				*/
/*						*/
/************************************************/
static STRMTY **freestreams(STRMTY **strms)

{
if (strms!=(STRMTY **)0) {
  int i;

  for (i=0;strms[i]!=(STRMTY *)0;i++) 
    strms[i]=tru_freestrm(strms[i]);
  (void) free(strms);
  strms=(STRMTY **)0; 
  }
return strms;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get the next character from*/
/*	the data-header				*/
/*						*/
/************************************************/
static char getnextchar()

{
int c;

c=EOF;
if (lines[numline]!=(char *)0) {
  curline=numline;
  currow=numrow;
  if ((numrow==0)&&(debug>0)) {
    char *addstr;

    addstr="";
    if (strlen(lines[numline])>MXSTR)
      addstr="...";
    (void) clm_alert(9,"%6d line=<%.*s%s>",numline+1,MXSTR,lines[numline],addstr);
    }
  c=(int)lines[numline][numrow];
  if (c=='\000') {
    c=' ';
    numrow=0;
    numline++;
    }
  else
    numrow++;
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to skip all blank character	*/
/*						*/
/************************************************/
static int skipblank()

{
int c;

c=EOF;
do {
  c=getnextchar();
  }
while (isblank(c)!=false);
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to make a ip/maks string	*/
/*						*/
/************************************************/
static STRMTY *mkipmask(char *ip,int mask,int limit)

{
STRMTY *strm;

strm=(STRMTY *)0;
if (mask>limit) {
  char *trbl;

  (void) asprintf(&trbl,"Mask value unexpected (above %d)",limit);
  (void) yyerror(trbl);
  (void) free(trbl);
  mask=limit;
  }
if (ip==(char *)0)
  (void) yyerror("IP number missing");
else {
  strm=(STRMTY *)calloc(1,sizeof(STRMTY)); 
  strm->mask=mask;
  strm->ip=ip;
  }
return strm;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to add a stream component to	*/
/*	the streamlist list.			*/
/*						*/
/************************************************/
static STRMTY **addstream(STRMTY **streams,STRMTY *stream)

{
if (stream!=(STRMTY *)0) {
  streams=(STRMTY **)vec_addlstlst((void **)streams,(void *)stream);
  }
return streams;
}
/************************************************/
/************************************************/
#line 232 "gestru.y"
typedef union  {
	STRMTY **strms;	/*full streams parsed	*/
	STRMTY *strm;	/*one trust data stream	*/
	DLGTYP *dlg;	/*data stream info	*/
	DLGTYP **dlgs;	/*data stream infos	*/
	long time;	/*time value as a long	*/
	char *strtime;	/*time as a str(long)	*/
	char *string;	/*the info is a string	*/
	char punct;	/*one char only		*/
	long integer;	/*the value is integer	*/
	char *word;	/*the info is a word	*/
	} YYSTYPE;
#line 279 "gestru.c"
#define YYERRCODE 256
#define STOP 257
#define CRLF 258
#define PLUS 259
#define MINUS 260
#define EQUAL 261
#define COMMA 262
#define SEMICOL 263
#define SLASH 264
#define COLON 265
#define DOT 266
#define PARLEFT 267
#define PARRIGHT 268
#define CURLEFT 269
#define CURIGHT 270
#define BRKLEFT 271
#define BRKRIGHT 272
#define PUNCT 273
#define FROM 274
#define BAN 275
#define STD 276
#define STATUS 277
#define BY 278
#define JAN 279
#define FEB 280
#define MAR 281
#define APR 282
#define MAY 283
#define JUN 284
#define JUL 285
#define AUG 286
#define SEP 287
#define OCT 288
#define NOV 289
#define DEC 290
#define MON 291
#define TUE 292
#define WED 293
#define THU 294
#define FRI 295
#define SAT 296
#define SUN 297
#define WORD 298
#define INTEGER 299
#define HEXA 300
#define STRING 301
#define IPV6 302
const short gestrulhs[] = {                                        -1,
    0,    0,    1,    1,    1,    2,    2,    3,    3,    4,
    4,    7,    7,    7,   11,   11,    8,    9,   14,   14,
    5,    6,    6,   16,   16,   16,   16,   17,   17,   12,
   12,   12,   13,   13,   13,   19,   19,   19,   10,   10,
   22,   22,   23,   23,   25,   25,   25,   25,   25,   25,
   25,   25,   25,   25,   25,   25,   25,   24,   24,   24,
   26,   26,   28,   29,   27,   27,   15,   18,   18,   21,
   21,   21,   21,   21,   21,   21,   30,   30,   30,   31,
   31,   32,   32,   33,   20,   20,   20,   20,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,
};
const short gestrulen[] = {                                         2,
    3,    3,    1,    2,    2,    3,    3,    3,    3,    1,
    3,    1,    2,    3,    3,    2,    3,    2,    1,    1,
    7,    1,    3,    1,    4,    4,    3,    1,    3,    1,
    1,    1,    5,    2,    1,    1,    3,    3,    3,    1,
    2,    1,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    1,    1,
    5,    3,    1,    1,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
    0,    1,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,
};
const short gestrudefred[] = {                                      0,
    0,    0,   69,    0,    0,    0,    3,    0,    0,    0,
    0,   22,    0,   28,    0,    0,    5,    0,    4,    0,
    0,   71,   72,   73,   74,   75,   76,   70,    0,    0,
   10,   12,    0,    0,    0,   40,    0,    0,    0,    0,
    0,    2,   68,   23,    1,    7,   35,   93,   91,   89,
   90,  101,  102,  103,  104,  105,  106,  107,  108,  109,
  110,  111,  112,   94,   95,   96,   97,   98,   99,  100,
   88,   85,   86,   92,   18,    0,   36,   87,   57,   45,
   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
   56,    0,    0,    6,   44,   13,    0,    0,    0,    0,
   77,   66,   63,   41,    0,   60,    0,    0,    8,    9,
   67,    0,    0,   27,   29,   34,    0,    0,    0,   43,
   11,    0,    0,   14,   32,   30,   31,   17,   39,   79,
   58,    0,    0,    0,   26,    0,   38,    0,   37,   16,
    0,   64,    0,    0,   65,    0,    0,   19,   20,    0,
   15,    0,   84,    0,   82,    0,   33,   61,   80,   83,
   21,
};
const short gestrudgoto[] = {                                       5,
    6,    7,    8,   30,    9,   10,   31,   32,   33,   34,
  124,  128,   75,  150,   11,   12,   13,   14,   76,  153,
   35,   36,   37,  104,   92,  105,  106,  107,  143,  108,
  145,  154,  155,   78,
};
const short gestrusindex[] = {                                   -244,
 -259,    0,    0, -203,    0, -248,    0, -207, -238, -188,
 -198,    0, -174,    0, -164, -283,    0, -159,    0, -160,
 -252,    0,    0,    0,    0,    0,    0,    0, -150, -191,
    0,    0, -182, -170, -137,    0, -194, -147, -146, -141,
 -204,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -251,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -140, -173,    0,    0,    0, -199, -115, -246, -111,
    0,    0,    0,    0, -239,    0,  -93, -104,    0,    0,
    0,  -65, -149,    0,    0,    0,  -77,  -47,  -77,    0,
    0,  -44, -173,    0,    0,    0,    0,    0,    0,    0,
    0,  -72,  -37, -141,    0,  -36,    0, -220,    0,    0,
 -256,    0,  -34,  -77,    0,  -33, -283,    0,    0,  -35,
    0,  -72,    0, -106,    0, -141,    0,    0,    0,    0,
    0,
};
const short gestrurindex[] = {                                      0,
    0, -118,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -253,    0,    0,    0,    0,    0,    0, -132,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -114,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -71,
    0,    0,    0,    0, -113,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -112,    0,    0, -195,    0,    0,    0,    0,
    0,    0, -196,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
const short gestrugindex[] = {                                      0,
    0,  226,    0,  111,  -38,   97,  143,  205,    0,  206,
    0,    0,    0,    0,  -40,  224,  128,  -39,    0,  -20,
    0,  144,    0,    0,    0,    0,  137,    0,   92,    0,
    0,    0,   91,    0,
};
#define YYTABLESIZE 245
const short gestrutable[] = {                                     112,
   77,  115,  114,   47,  116,   93,   15,   17,  117,   95,
   24,    1,  118,  151,  119,   43,    3,   18,   24,  100,
  101,   48,   49,   50,   51,   38,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   20,   74,
    2,    3,   29,    4,    2,    3,  122,    4,  102,   62,
  113,   16,   62,   62,  100,  101,   21,   40,   25,  123,
   93,   94,   62,   95,  135,   39,   25,   98,    2,    3,
   62,    4,   95,   22,   23,   24,   25,   26,   27,   28,
   41,   29,   42,  146,    2,    3,  137,   45,  139,  148,
   21,   62,   46,  102,  103,   79,   98,  115,   22,   23,
   24,   25,   26,   27,   28,  161,   29,   22,   23,   24,
   25,   26,   27,   28,   99,   29,   44,   44,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
  125,   42,   59,   81,   44,   68,   68,   67,  130,    2,
    3,  109,  110,   68,   42,   59,   81,  111,  120,  126,
  127,  159,   42,   59,   81,   44,   44,   48,   49,   50,
   51,  132,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
   70,   71,   72,   73,  133,   74,   48,   49,   50,   51,
  134,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,  138,   74,  140,  142,   78,  147,  144,
  152,   19,  156,  141,  149,  121,  157,   96,   97,   44,
  136,  131,  129,  158,  160,
};
const short gestrucheck[] = {                                      40,
   21,   41,   41,  256,  256,  262,  266,  256,  260,  256,
  264,  256,  264,  270,  266,  299,  300,  266,  272,  259,
  260,  274,  275,  276,  277,  264,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  256,  302,
  299,  300,  299,  302,  299,  300,  256,  302,  298,  256,
  265,  265,  259,  260,  259,  260,  274,  266,  264,  269,
  262,  263,  269,  256,  113,  264,  272,  277,  299,  300,
  277,  302,  256,  291,  292,  293,  294,  295,  296,  297,
  265,  299,  257,  134,  299,  300,  117,  257,  119,  138,
  274,  298,  263,  298,  299,  256,  277,  147,  291,  292,
  293,  294,  295,  296,  297,  156,  299,  291,  292,  293,
  294,  295,  296,  297,  262,  299,  259,  260,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  256,  256,  256,  256,  277,  264,  265,  266,  260,  299,
  300,  299,  299,  272,  269,  269,  269,  299,  299,  275,
  276,  268,  277,  277,  277,  298,  299,  274,  275,  276,
  277,  265,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  299,  302,  274,  275,  276,  277,
  266,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  271,  302,  270,  299,  299,  265,  267,
  265,    6,  266,  123,  138,   93,  272,   33,   33,   16,
  113,  105,   99,  152,  154,
};
#define YYFINAL 5
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 302
#if YYDEBUG
const char * const gestruname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"STOP","CRLF","PLUS","MINUS",
"EQUAL","COMMA","SEMICOL","SLASH","COLON","DOT","PARLEFT","PARRIGHT","CURLEFT",
"CURIGHT","BRKLEFT","BRKRIGHT","PUNCT","FROM","BAN","STD","STATUS","BY","JAN",
"FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC","MON","TUE",
"WED","THU","FRI","SAT","SUN","WORD","INTEGER","HEXA","STRING","IPV6",
};
const char * const gestrurule[] = {
"$accept : dlgs",
"dlgs : streams DOT STOP",
"dlgs : error DOT STOP",
"streams : stream",
"streams : streams stream",
"streams : streams error",
"stream : network infos SEMICOL",
"stream : network error SEMICOL",
"network : ipv4 SLASH INTEGER",
"network : ipv6 SLASH INTEGER",
"infos : info",
"infos : infos COMMA info",
"info : data",
"info : from data",
"info : from datetime capinfo",
"capinfo : CURLEFT infos CURIGHT",
"capinfo : error CURIGHT",
"data : datetime STATUS status",
"from : FROM origine",
"ip : ipv4",
"ip : ipv6",
"ipv4 : byte DOT byte DOT byte DOT byte",
"ipv6 : numipv6",
"ipv6 : IPV6 COLON numipv6",
"numipv6 : pureipv6",
"numipv6 : pureipv6 COLON COLON pureipv6",
"numipv6 : pureipv6 COLON COLON ipv4",
"numipv6 : pureipv6 COLON ipv4",
"pureipv6 : hexa",
"pureipv6 : pureipv6 COLON hexa",
"status : BAN",
"status : STD",
"status : error",
"origine : domains SLASH BRKLEFT ip BRKRIGHT",
"origine : domains error",
"origine : error",
"domains : word",
"domains : domains DOT word",
"domains : domains MINUS word",
"datetime : days COMMA cachet",
"datetime : cachet",
"cachet : date time",
"cachet : date",
"date : INTEGER months INTEGER",
"date : error",
"months : JAN",
"months : FEB",
"months : MAR",
"months : APR",
"months : MAY",
"months : JUN",
"months : JUL",
"months : AUG",
"months : SEP",
"months : OCT",
"months : NOV",
"months : DEC",
"months : error",
"time : hours zone",
"time : hours",
"time : zone",
"hours : hour COLON sixty COLON sixty",
"hours : hour COLON sixty",
"hour : INTEGER",
"sixty : INTEGER",
"zone : sign INTEGER optime",
"zone : WORD",
"byte : INTEGER",
"hexa : INTEGER",
"hexa : HEXA",
"days : SUN",
"days : MON",
"days : TUE",
"days : WED",
"days : THU",
"days : FRI",
"days : SAT",
"sign : MINUS",
"sign : PLUS",
"sign : PLUS MINUS",
"optime : PARLEFT comments PARRIGHT",
"optime :",
"comments : comment",
"comments : comments comment",
"comment : word",
"word : INTEGER",
"word : HEXA",
"word : keyword",
"word : WORD",
"keyword : STD",
"keyword : STATUS",
"keyword : BAN",
"keyword : IPV6",
"keyword : FROM",
"keyword : MON",
"keyword : TUE",
"keyword : WED",
"keyword : THU",
"keyword : FRI",
"keyword : SAT",
"keyword : SUN",
"keyword : JAN",
"keyword : FEB",
"keyword : MAR",
"keyword : APR",
"keyword : MAY",
"keyword : JUN",
"keyword : JUL",
"keyword : AUG",
"keyword : SEP",
"keyword : OCT",
"keyword : NOV",
"keyword : DEC",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 882 "gestru.y"
#include	<memory.h>
#include	<ctype.h>
#include	<errno.h>
/*

*/
/************************************************/
/*						*/
/*	Procedure to really clean the YACC	*/
/*	satructure.				*/
/*						*/
/************************************************/
static void cleanyyparse()

{
#ifdef	YYINITSTACKSIZE
#if	YYPATCH >= 20100216
/*procedure already included byacc-1.9		*/
#else
/*to free yyparse dynamically allocated memory	*/
if (yyvs!=(YYSTYPE *)0) {
  (void) free(yyvs);
  yyvs=(YYSTYPE *)0;
  }
if (yyss!=(short *)0) {
  (void) free(yyss);
  yyss=(short *)0;
  }
yystacksize=0;
#endif
#endif
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to report a parsing error	*/
/*	debugging mode only.			*/
/*						*/
/************************************************/
static void yyerror(char *info)

{
int dbg;

dbg=0;	/*0 Trusted/Banned streams parsing check*/
if ((clm_foreground==true)||(debug>=dbg)) {
  int i;
  char crlf[3];
  char lasttoken[50];

  (void) strcpy(crlf,"");
  (void) strcpy(lasttoken,"");
  if (strcmp(info,"syntax error")==0)
    (void) sprintf(lasttoken," (last token found='%d')",lastcode);
  for (i=0;lines[curline][i]!='\000';i++)
    if (isspace(lines[curline][i])!=false)
      lines[curline][i]=' ';
  if (currow>=strlen(lines[curline]))
    (void) strcpy(crlf," ");
  (void) clm_alert(dbg,"% 6d %.*s",curline+1,currow+2,lines[curline]);
  (void) clm_alert(dbg,"%*s %*s%s",6,"",currow+1,"^",info);
  }
nbrerr++;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the punct char	*/
/*	value.					*/ 	
/*						*/
/************************************************/
static int punctchar(char c)

{
int code;

code=PUNCT;
switch (c) {
  case ':'	:
    code=COLON;
    break;
  case ';'	:
    code=SEMICOL;
    break;
  case ','	:
    code=COMMA;
    break;
  case '.'	:
    code=DOT;
    break;
  case '+'	:
    code=PLUS;
    break;
  case '-'	:
    code=MINUS;
    break;
  case '='	:
    code=EQUAL;
    break;
  case '/'	:
    code=SLASH;
    break;
  case '['	:
    code=BRKLEFT;
    break;
  case ']'	:
    code=BRKRIGHT;
    break;
  case '('	:
    code=PARLEFT;
    break;
  case ')'	:
    code=PARRIGHT;
    break;
  case '{'	:
    code=CURLEFT;
    break;
  case '}'	:
    code=CURIGHT;
    break;
  default	:
    code=PUNCT;
    break;
  }
return code;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the token value 	*/
/*	from a string				*/
/*						*/
/************************************************/
static int tokenfromstr(char *strtoken,int *disp)

{
/*	Token list				*/
static struct	{
	int code;
	char *string;
	}vocable[]={/*MUST in length order	*/
		   {STD,	STRSTD},
		   {STATUS,	STRSTA},
		   {BAN,	STRBAN},
		   {FROM,	STRFRM},
		   {IPV6,	STRIPV6},
		   {MON,"Mon"},{TUE,"Tue"},{WED,"Wed"},{THU,"Thu"},
		   {FRI,"Fri"},{SAT,"Sat"},{SUN,"Sun"},
		   {JAN,"Jan"},{FEB,"Feb"},{MAR,"Mar"},{APR,"Apr"},
		   {MAY,"May"},{JUN,"Jun"},{JUL,"Jul"},{AUG,"Aug"},
		   {SEP,"Sep"},{OCT,"Oct"},{NOV,"Nov"},{DEC,"Dec"},
		   {WORD,(char *)0}
		   };

int token;
int i;

*disp=0;
token=WORD;
for (i=0;vocable[i].string!=(char *)0;i++) {
  *disp=strlen(vocable[i].string);
  if (strncasecmp(vocable[i].string,strtoken,*disp)==0) {
    ykeyword=vocable[i].string;
    token=vocable[i].code;
    break;
    }
  }
return token;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to backspace in the header	*/
/*	the data-header				*/
/*						*/
/************************************************/
static void backspace()

{
numline=curline;
numrow=currow;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract a string on a line	*/
/*						*/
/************************************************/
static char *getstring()

{
#define STRINC  20

char c;
char *strloc;
int locnumline;
int locnumrow;

locnumline=numline;
locnumrow=numrow;
strloc=(char *)calloc(1,STRINC+5);
while ((c=getnextchar())!=EOF) {
  int bspace;
  char ajout[2];

  bspace=false;
  if ((strlen(strloc)%STRINC)==0) {
    strloc=(char *)realloc(strloc,(((strlen(strloc)/STRINC)+1)*STRINC)+5);
    }
  bspace=((strlen(strloc)>1)&&(strloc[strlen(strloc)]=='\\'));
  if ((c=='\n')&&(bspace==false)) {
    (void) free(strloc);
    strloc=(char *)0;
    numline=locnumline;
    numrow=locnumrow;
    break;
    }
  if ((c=='\"')&&(bspace==false))
    break;
  ajout[0]=c;
  (void) strncat(strloc,ajout,1);
  }
return strloc;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get/recognise a lexical	*/
/*	input.					*/
/*						*/
/************************************************/
static int yylex()

{
#define MXINFO	200

int found;
int c;
int proceed;
int phase;
int disp;
int numerique;
char info[MXINFO];

found=STOP;
phase=0;
proceed=true;
disp=0;
numerique=false;
(void) memset(info,'\000',sizeof(info));
c=skipblank();
if (c==EOF) {
  if (cptstop>0) {
    (void) siglongjmp(manystop,1);
    }
  cptstop++;
  return STOP;
  }
while (proceed==true) {
  switch (phase) {
    case     0	:	/*looking for strings	*/
      if (c=='\"') {
        if ((yylval.string=getstring())!=(char *)0) {
	  found=STRING;
	  proceed=false;
	  }
	}
      break;
    case     1	:	/* looking for punct	*/
      if (isalnum(c)==false) {
        found=punctchar(c);
	yylval.punct=(char)c;
	proceed=false;
	}
      break;
    case     2	:	/* looking for keyword	*/
      if ((found=tokenfromstr(lines[numline]+(numrow-1),&disp))!=WORD) {
	char *ptr;

	ptr=lines[numline]+(numrow-1)+disp;
	if (isalnum(*ptr)==false) {
	  numrow+=(disp-1);
	  proceed=false;
	  }
	}
      break;
    case     3	:	/*checking if word could be numeric	*/
      if (isdigit(c)!=false) 
	numerique=true;
      break;
    case     4	:	/*extracting word			*/
      {
      int extract;
      unsigned int inx;

      extract=true;
      inx=0;
      while (extract==true) {
        info[inx++]=c;
        if ((c=getnextchar())==EOF) {
          found=STOP;
	  if (cptstop>0)
	    (void) siglongjmp(manystop,1);
	  cptstop++;
	  extract=false;
	  break;
          }
        if (inx>=sizeof(info))
          extract=false;
        if (extract==false)
	  break;
        extract=(isalnum(c)!=false);
	}
      (void) backspace();
      }
      break;
    case     5	:	/* Is it a pure integer	*/
      if (numerique==true) {
	int i;

	for (i=1;info[i]!='\000';i++) {
	  if (isdigit(info[i])!=false)
	    continue;
	  numerique=false;
	  break;
	  }
	if (numerique==true) {
          yylval.integer=atol(info);
          found=INTEGER;
      	  proceed=false;
	  }
	}
      break;
    case     6	:	/*Is it an exhadecimal	*/
      if (strlen(info)>0) {
	int hexa;
	int i;

	hexa=true;
	for (i=0;info[i]!='\000';i++) {
	  if (isxdigit(info[i])!=false)
	    continue;
	  hexa=false;
	  break;
	  }
	if (hexa==true) {
	  yylval.integer=strtol(info,(char **)0,16);
          found=HEXA;
      	  proceed=false;
	  }
	}
      break;
    default	:	/*safe guard			*/
      yylval.word=strdup(info);
      found=WORD;
      proceed=false;
      break;
    }
  phase++;
  }
#ifdef DEBUG
if (yydebug>0) {
  /*synchronizing yydebug output	*/
  (void) fflush(stdout);
  (void) fflush(stderr);
  }
#endif
lastcode=found;
(void) clm_alert(11,"return token (value='%d')",found);
return found;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to parse an return a stream	*/
/*						*/
/************************************************/
static STRMTY **parsestream(char **trustlst)

{
STRMTY **parsed;
int verybad;

parsed=(STRMTY **)0;
verybad=false;
cptstop=0;
lines=trustlst;
numline=0;
numrow=0;
itsok=true;
nbrerr=0;
#ifdef DEBUG
if (debug>11)	/*debugging all yacc analyze	*/
  yydebug=1;
#endif
if (sigsetjmp(manystop,true)==0) 
  verybad=yyparse(); 
else 
  verybad=true;
parsed=ystrms;
ystrms=(STRMTY **)0;
(void) cleanyyparse();
if (verybad==true) 
  parsed=freestreams(parsed); 
return parsed;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to look at trusted data stream*/
/*	information and build sequence.		*/
/*						*/
/************************************************/
TRUTYP *tru_parsetrust(char *peername,char *peerip,char **trustlst)

{
#define	OPPA	"gestru.y:tru_parsetrust,"

TRUTYP *trust;
GACTYP *gat;
STRMTY **parsed;
int phase;
int proceed;

trust=(TRUTYP *)0;
gat=(GACTYP *)0;
parsed=(STRMTY **)0;
phase=0;
proceed=true;
while (proceed==true) {
  switch (phase) {
    case 0	:	/*open Garbage Collector*/
      if ((gat=gac_open(0,appname,"parsing_banned_stream"))==(GACTYP *)0) {
	(void) clm_alert(0,"%s Unable to open garbage collector (errno=<%s> bug?)",
			   OPPA,strerror(errno));
	phase=999;	/*big trouble		*/
	}
      break;
    case 1	:	/*parsing under GC	*/
      if ((parsed=parsestream(trustlst))==(STRMTY **)0)
	phase++;	/*no need to duplicat	*/
      break;
    case 2	:	/*dup stream without GC	*/
      if (parsed!=(STRMTY **)0)	{/*always	*/
	long remaining;
	STRMTY **clone;
	int i;

	(void) gac_gear(gear_down,&remaining);
	clone=(STRMTY **)0;
  	for (i=0;parsed[i]!=(STRMTY *)0;i++) {
    	  STRMTY *loc;

    	  loc=tru_dupstrm(parsed[i]);
          clone=(STRMTY **)vec_addlstlst((void **)clone,(void *)loc);
	  }
  	trust=(TRUTYP *)calloc(1,sizeof(TRUTYP));
  	trust->peername=strdup(peername);
  	trust->peerip=strdup(peerip);
  	trust->strms=clone; 
	(void) gac_gear(gear_up,&remaining);
  	parsed=freestreams(parsed); 
    	}
      break;
    case 3	:	/*cleaning trash	*/
       (void) clm_trashmem(1,gat);
      break;
    default	:	/*SAFE Guard		*/
      proceed=false;
      break;
    }
  phase++;
  }
return trust;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free momory used by a	*/
/*	DLGTYP structure.			*/
/*	to a fresh identical structure.		*/
/*						*/
/************************************************/
DLGTYP *tru_freedlg(DLGTYP *dlg)

{
if (dlg!=(DLGTYP *)0) {
  if (dlg->flgdata==false)
    dlg->frwdata.frw=freedlgs(dlg->frwdata.frw);
  dlg->orig=clm_freestr(dlg->orig);
  (void) free(dlg);
  dlg=(DLGTYP *)0;
  }
return dlg;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to duplicate an DLGTYP struct	*/
/*	to a fresh identical structure.		*/
/*						*/
/************************************************/
DLGTYP *tru_dupdlg(DLGTYP *dlg)

{
DLGTYP *ndlg;

ndlg=(DLGTYP *)0;
if (dlg!=(DLGTYP *)0) {
  ndlg=(DLGTYP *)calloc(1,sizeof(DLGTYP));
  ndlg->orig=strdup(dlg->orig);
  ndlg->flgt=dlg->flgt;
  ndlg->flgdata=dlg->flgdata;
  if (ndlg->flgdata==true)
    ndlg->frwdata.status=dlg->frwdata.status;
  else
    ndlg->frwdata.frw=dupdlgs(dlg->frwdata.frw);
  }
return ndlg;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to locat within STRMTY struct	*/
/*	a BANNED information coming from the	*/
/*	same origin.				*/
/*						*/
/************************************************/
DLGTYP **tru_locdlg(STRMTY *strm,DLGTYP *dlg)

{
DLGTYP **spoted;

spoted=(DLGTYP **)0;
if ((strm!=(STRMTY *)0)&&(strm->data!=(DLGTYP **)0)) {
  DLGTYP **data;

  for (data=strm->data;*data!=(DLGTYP *)0;data++) {
    if (strcmp((*data)->orig,dlg->orig)==0) {
      spoted=data;
      break;
      }
    }
  }
return spoted;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to dump data within DLGTYP	*/
/*	structure.				*/
/*						*/
/************************************************/
char **tru_dumpdlgs(DLGTYP **dlgs,int tab)

{
static char *strcode[]={"UKN",STRSTD,STRBAN};

char **strdlgs;

strdlgs=(char **)0;
if (dlgs!=(DLGTYP **)0) {
  int i;

  for (i=0;dlgs[i]!=(DLGTYP *)0;i++) {
    char *str;
    char **strs;
    char sdate[100];

    str=(char *)0;
    strs=(char **)0;
    (void) strcpy(sdate,clm_ascsysstamp(dlgs[i]->flgt));
    switch (dlgs[i]->flgdata) {
      case false	:
	if ((strs=tru_dumpdlgs(dlgs[i]->frwdata.frw,tab+2))!=(char **)0) {
	  int j;

	  (void) asprintf(&str,"%*s%s %s %s",tab,"",STRFRM,dlgs[i]->orig,sdate);
          strdlgs=(char **)vec_addlstlst((void **)strdlgs,(void *)str);
	  (void) asprintf(&str,"%*s{",tab+2,"");
          strdlgs=(char **)vec_addlstlst((void **)strdlgs,(void *)str);
          for (j=0;strs[j]!=(char *)0;j++) {
            strdlgs=(char **)vec_addlstlst((void **)strdlgs,(void *)strs[j]);
	    str=strs[j];
	    }
          (void) free(strs);
          str[strlen(str)-1]='\000';
	  (void) asprintf(&str,"%*s},",tab+2,"");
          strdlgs=(char **)vec_addlstlst((void **)strdlgs,(void *)str);
	  }
	break;
      default		:
 	if (dlgs[i]->frwdata.status>BANBAN)
	  dlgs[i]->frwdata.status=BANUKN;	
	if (strlen(dlgs[i]->orig)>0)
	  (void) asprintf(&str,"%*s%s %s %s %s %s,",
			        tab,"",STRFRM,dlgs[i]->orig,sdate,
				STRSTA,strcode[dlgs[i]->frwdata.status]);
	else
	  (void) asprintf(&str,"%*s%s %s %s,",
			        tab,"",sdate,STRSTA,strcode[dlgs[i]->frwdata.status]);
        strdlgs=(char **)vec_addlstlst((void **)strdlgs,str);
	break;
      }
    if ((dlgs[i+1]==(DLGTYP *)0)&&(str!=(char *)0)&&(strlen(str)>0))
      str[strlen(str)-1]=';';
    }
  }
return strdlgs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to duplicate an STRMTY struct	*/
/*	to a fresh identical structure.		*/
/*						*/
/************************************************/
STRMTY *tru_dupstrm(STRMTY *strm)

{
STRMTY *nstrm;

nstrm=(STRMTY *)0;
if (strm!=(STRMTY *)0) {
  nstrm=(STRMTY *)calloc(1,sizeof(STRMTY));
  nstrm->ip=strdup(strm->ip);
  nstrm->mask=strm->mask;
  nstrm->data=dupdlgs(strm->data);
  }
return nstrm;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free the memory used by	*/
/*	a STRMTY * structure			*/
/*						*/
/************************************************/
STRMTY *tru_freestrm(STRMTY *strm)

{
if (strm!=(STRMTY *)0) {
  strm->data=freedlgs(strm->data);
  strm->ip=clm_freestr(strm->ip);
  (void) free(strm);
  strm=(STRMTY *)0;
  }
return strm;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free the memory used by	*/
/*	a TRUTYP ** structure			*/
/*						*/
/************************************************/
TRUTYP *tru_freetrusts(TRUTYP *dattrusts)

{
if (dattrusts!=(TRUTYP *)0) {
  dattrusts->strms=freestreams(dattrusts->strms);
  dattrusts->peerip=clm_freestr(dattrusts->peerip);
  dattrusts->peername=clm_freestr(dattrusts->peername);
  (void) free(dattrusts);
  dattrusts=(TRUTYP *)0; 
  }
return dattrusts;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to do an ASCII dump of 	*/
/*	trust data.				*/
/*						*/
/************************************************/
char **tru_dumpstrm(char *myname,char *myip,STRMTY *strm)

{
char **strstrms;

strstrms=(char **)0;
if (strm!=(STRMTY *)0) {
  char *str;
  char **dlgs;

  (void) asprintf(&str,"#-Received by %s/[%s]",myname,myip);
  strstrms=(char **)vec_addlstlst((void **)strstrms,(void *)str);
  (void) asprintf(&str,"%s/%d",strm->ip,strm->mask);
  strstrms=(char **)vec_addlstlst((void **)strstrms,(void *)str);
  if ((dlgs=tru_dumpdlgs(strm->data,4))!=(char **)0) {
    int j;
    
    for (j=0;dlgs[j]!=(char *)0;j++) 
      strstrms=(char **)vec_addlstlst((void **)strstrms,(void *)dlgs[j]);
    (void) free(dlgs);
    }
  }
return strstrms;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to preapre ASCII conversion	*/
/*	of the stream, adding the origin.	*/
/*						*/
/************************************************/
void tru_setorigin(TRUTYP *dattrusts)

{
if (dattrusts!=(TRUTYP *)0) {
  char *origin;

  (void) asprintf(&origin,"%s/[%s]",dattrusts->peername,dattrusts->peerip);
  if (dattrusts->strms!=(STRMTY **)0) {
    STRMTY **ptr;

    for (ptr=dattrusts->strms;*ptr!=(STRMTY *)0;ptr++) {
      if ((*ptr)->data!=(DLGTYP **)0) {
	DLGTYP **dlgs;
	int count;

	dlgs=(*ptr)->data;
	count=vec_sizelstlst((void **)dlgs);
	if ((count==1)&&(strlen((*dlgs)->orig)==0)) {
	  (void) free((*dlgs)->orig);
	  (*dlgs)->orig=strdup(origin);
	  }
	else {
	  DLGTYP *dlg;

	  dlg=(DLGTYP *)calloc(1,sizeof(DLGTYP));
	  dlg->orig=strdup(origin);
	  dlg->flgt=time((time_t *)0);
	  dlg->flgdata=false;
	  dlg->frwdata.frw=dlgs;
          (*ptr)->data=(DLGTYP **)vec_addlstlst((void **)0,(void *)dlg);
	  }
	}
      }
    }
  (void) free(origin);
  }
}
#line 1419 "gestru.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 308 "gestru.y"
{
			ystrms=(STRMTY **)0;
                        if (itsok==true) {
			  ystrms=yyvsp[-2].strms;
                          YYACCEPT;
			  }
                        else {
			  yyvsp[-2].strms=freestreams(yyvsp[-2].strms);
                          YYABORT;
			  }
			}
break;
case 2:
#line 320 "gestru.y"
{
			(void) yyerror("Fatal error stop");
			ystrms=(STRMTY **)0;
			YYABORT;
			}
break;
case 3:
#line 328 "gestru.y"
{
			yyval.strms=addstream((STRMTY **)0,yyvsp[0].strm);
			}
break;
case 4:
#line 332 "gestru.y"
{
			yyval.strms=yyvsp[-1].strms;
			if (yyvsp[0].strm!=(STRMTY *)0)
			  yyval.strms=addstream(yyvsp[-1].strms,yyvsp[0].strm);
			}
break;
case 5:
#line 338 "gestru.y"
{
			(void) yyerror("Fatal streams error");
			yyval.strms=freestreams(yyvsp[-1].strms);
			itsok=false;
			}
break;
case 6:
#line 346 "gestru.y"
{
		        yyval.strm=yyvsp[-2].strm;
			if (yyvsp[-2].strm!=(STRMTY *)0) {
			  if (yyvsp[-1].dlgs!=(DLGTYP **)0)
			    yyvsp[-2].strm->data=yyvsp[-1].dlgs;	
			  else
			    itsok=false;
			  }
			else {
			  if (yyvsp[-1].dlgs!=(DLGTYP **)0)
			    yyvsp[-1].dlgs=freedlgs(yyvsp[-1].dlgs);
			  itsok=false;
			  }
			}
break;
case 7:
#line 361 "gestru.y"
{
			(void) yyerror("Fatal Error Parsing stream data");
			yyval.strm=tru_freestrm(yyvsp[-2].strm);
			}
break;
case 8:
#line 368 "gestru.y"
{
			yyval.strm=mkipmask(yyvsp[-2].string,yyvsp[0].integer,32);
			}
break;
case 9:
#line 372 "gestru.y"
{
			yyval.strm=mkipmask(yyvsp[-2].string,yyvsp[0].integer,128);
			}
break;
case 10:
#line 379 "gestru.y"
{
			if (yyvsp[0].dlg!=(DLGTYP *)0) 
			  yyval.dlgs=(DLGTYP **)vec_addlstlst((void **)0,(void *)yyvsp[0].dlg);
			}
break;
case 11:
#line 384 "gestru.y"
{
			if (yyvsp[-2].dlg!=(DLGTYP *)0) 
			  yyval.dlgs=(DLGTYP **)vec_addlstlst((void **)yyvsp[-2].dlgs,(void *)yyvsp[0].dlg);
			}
break;
case 12:
#line 391 "gestru.y"
{
			if (yyvsp[0].dlg!=(DLGTYP *)0) 
			  (void) asprintf(&(yyvsp[0].dlg->orig),"%s","");
			yyval.dlg=yyvsp[0].dlg;
			}
break;
case 13:
#line 397 "gestru.y"
{
			if (yyvsp[0].dlg!=(DLGTYP *)0) 
			  yyvsp[0].dlg->orig=yyvsp[-1].string;
			yyval.dlg=yyvsp[0].dlg;
			}
break;
case 14:
#line 403 "gestru.y"
{
			yyval.dlg=(DLGTYP *)0;
			if (yyvsp[0].dlg!=(DLGTYP *)0) {
			  yyval.dlg=(DLGTYP *)calloc(1,sizeof(DLGTYP));
			  yyval.dlg->orig=yyvsp[-2].string;
			  if (yyvsp[-1].strtime!=(char *)0) {
			    yyval.dlg->flgt=atol(yyvsp[-1].strtime);
			    (void) free(yyvsp[-1].strtime);
			    }
			  yyval.dlg->flgdata=false;
			  yyval.dlg->frwdata.frw=yyvsp[0].dlgs;
			  }
			}
break;
case 15:
#line 419 "gestru.y"
{
			yyval.dlg=yyvsp[-1].dlg;
			}
break;
case 16:
#line 423 "gestru.y"
{
			yyval.dlg=(DLGTYP *)0;
			}
break;
case 17:
#line 429 "gestru.y"
{
			yyval.dlg=(DLGTYP *)calloc(1,sizeof(DLGTYP));
			if (yyvsp[-2].strtime!=(char *)0) {
			  yyval.dlg->flgt=atol(yyvsp[-2].strtime);
			  (void) free(yyvsp[-2].strtime);
			  }
			yyval.dlg->flgdata=true;
			yyval.dlg->frwdata.status=yyvsp[0].integer;
			}
break;
case 18:
#line 441 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			}
break;
case 19:
#line 447 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			}
break;
case 20:
#line 451 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			}
break;
case 21:
#line 457 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%ld.%ld.%ld.%ld",
				yyvsp[-6].integer,yyvsp[-4].integer,yyvsp[-2].integer,yyvsp[0].integer);
			}
break;
case 22:
#line 464 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			if (yyvsp[0].string!=(char *)0) {
			  (void) asprintf(&(yyval.string),"ipv6:%s",yyvsp[0].string);
			  (void) free(yyvsp[0].string);
			  }
			}
break;
case 23:
#line 472 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			if (yyvsp[0].string!=(char *)0) {
			  (void) asprintf(&(yyval.string),"%s:%s",STRIPV6,yyvsp[0].string);
			  (void) free(yyvsp[0].string);
			  }
			}
break;
case 24:
#line 482 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			}
break;
case 25:
#line 486 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%s::%s",yyvsp[-3].string,yyvsp[0].string);
			(void) free(yyvsp[-3].string);
			(void) free(yyvsp[0].string);
			}
break;
case 26:
#line 492 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%s::%s",yyvsp[-3].string,yyvsp[0].string);
			(void) free(yyvsp[-3].string);
			(void) free(yyvsp[0].string);
			}
break;
case 27:
#line 498 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%s::%s",yyvsp[-2].string,yyvsp[0].string);
			(void) free(yyvsp[-2].string);
			(void) free(yyvsp[0].string);
			}
break;
case 28:
#line 506 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			}
break;
case 29:
#line 510 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%s:%s",yyvsp[-2].string,yyvsp[0].string);
			(void) free(yyvsp[-2].string);
			(void) free(yyvsp[0].string);
			}
break;
case 30:
#line 518 "gestru.y"
{
			yyval.integer=BANBAN;
			}
break;
case 31:
#line 522 "gestru.y"
{
			yyval.integer=BANSTD;
			}
break;
case 32:
#line 526 "gestru.y"
{
			(void) yyerror("Status can be one of ("STRBAN","STRSTD")");
			yyval.integer=BANSTD;
			}
break;
case 33:
#line 533 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%s/[%s]",yyvsp[-4].string,yyvsp[-1].string);
			(void) free(yyvsp[-4].string);
			(void) free(yyvsp[-1].string);
			}
break;
case 34:
#line 539 "gestru.y"
{
			yyval.string=(char *)0;
			(void) free(yyvsp[-1].string);
			}
break;
case 35:
#line 544 "gestru.y"
{
			yyval.string=(char *)0;
			}
break;
case 36:
#line 550 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			}
break;
case 37:
#line 554 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%s.%s",yyvsp[-2].string,yyvsp[0].string);
			(void) free(yyvsp[-2].string);
			(void) free(yyvsp[0].string);
			}
break;
case 38:
#line 560 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%s-%s",yyvsp[-2].string,yyvsp[0].string);
			(void) free(yyvsp[-2].string);
			(void) free(yyvsp[0].string);
			}
break;
case 39:
#line 568 "gestru.y"
{
			yyval.strtime=yyvsp[0].strtime;
			}
break;
case 40:
#line 572 "gestru.y"
{
			yyval.strtime=yyvsp[0].strtime;
			}
break;
case 41:
#line 578 "gestru.y"
{
		        yyvsp[-1].integer+=yyvsp[0].integer;
			(void) asprintf(&(yyval.strtime),"%ld",yyvsp[-1].integer);
			}
break;
case 42:
#line 583 "gestru.y"
{
			(void) asprintf(&(yyval.strtime),"%ld",yyvsp[0].integer);
			}
break;
case 43:
#line 589 "gestru.y"
{
			struct tm timing;

			(void) memset(&timing,'\000',sizeof(timing));
			timing.tm_mday=yyvsp[-2].integer;
			timing.tm_mon=yyvsp[-1].integer;
	 		if (yyvsp[0].integer<100)
			  yyvsp[0].integer+=2000;
			timing.tm_year=yyvsp[0].integer-1900;
			yyval.time=timegm(&timing);
			}
break;
case 44:
#line 601 "gestru.y"
{
			yyval.time=time((time_t *)0);
			}
break;
case 45:
#line 607 "gestru.y"
{
			yyval.integer=0;
			}
break;
case 46:
#line 611 "gestru.y"
{
			yyval.integer=1;
			}
break;
case 47:
#line 615 "gestru.y"
{
			yyval.integer=2;
			}
break;
case 48:
#line 619 "gestru.y"
{
			yyval.integer=3;
			}
break;
case 49:
#line 623 "gestru.y"
{
			yyval.integer=4;
			}
break;
case 50:
#line 627 "gestru.y"
{
			yyval.integer=5;
			}
break;
case 51:
#line 631 "gestru.y"
{
			yyval.integer=6;
			}
break;
case 52:
#line 635 "gestru.y"
{
			yyval.integer=7;
			}
break;
case 53:
#line 639 "gestru.y"
{
			yyval.integer=8;
			}
break;
case 54:
#line 643 "gestru.y"
{
			yyval.integer=9;
			}
break;
case 55:
#line 647 "gestru.y"
{
			yyval.integer=10;
			}
break;
case 56:
#line 651 "gestru.y"
{
			yyval.integer=11;
			}
break;
case 57:
#line 655 "gestru.y"
{
			yyval.integer=0;
			}
break;
case 58:
#line 661 "gestru.y"
{
			yyval.time=yyvsp[-1].time-yyvsp[0].time;
			}
break;
case 59:
#line 665 "gestru.y"
{
			yyval.time=yyvsp[0].time;
			}
break;
case 60:
#line 669 "gestru.y"
{
			yyval.time=-yyvsp[0].time;
			}
break;
case 61:
#line 675 "gestru.y"
{
			yyval.time=(((yyvsp[-4].time*60)+(yyvsp[-2].time))*60)+yyvsp[0].time;
			}
break;
case 62:
#line 679 "gestru.y"
{
			yyval.time=((yyvsp[-2].time*60)+(yyvsp[0].time))*60;
			}
break;
case 63:
#line 685 "gestru.y"
{
			yyval.time=yyvsp[0].integer;
			if (yyvsp[0].integer>24) {
			  (void) yyerror("Unexpected value (above 24 Hour)");
			  yyval.time=0;
			  } 
			}
break;
case 64:
#line 695 "gestru.y"
{
			yyval.time=yyvsp[0].integer;
			if (yyvsp[0].integer>60) {
			  (void) yyerror("Unexpected value (above 60)");
			  yyval.time=0;
			  } 
			}
break;
case 65:
#line 705 "gestru.y"
{
			yyval.time=((yyvsp[-1].integer/100)*3600)+((yyvsp[-1].integer%100)*60);
			yyval.time*=yyvsp[-2].integer;
			}
break;
case 66:
#line 710 "gestru.y"
{
			static struct {
				char *zname;
				int diff;
				}tznom[]={
					  {"UTC",-0},
					  {"Z",-0},
					  {"GMT",-0},
					  {"EST",-5},
					  {"EDT",-4},
					  {"CST",-6},
					  {"CDT",-5},
					  {"MST",-7},
					  {"MDT",-6},
					  {"PST",-8},
					  {"PDT",-7},
					  {"AKST",-9},
					  {"AKDT",-8},
					  {"HST",-10},
					  {"HST",-10},
					  {"BST",+1},
					  {"CET",+1},
					  {"CST",+2},
					  {(char *)0,0}
					  };
			int i;

			yyval.time=0;
			for (i=0;tznom[i].zname!=(char *)0;i++) {
			  if (strcasecmp(tznom[i].zname,yyvsp[0].word)==0) {
			    yyval.time=tznom[i].diff*3600;
			    break;
			    }
			  }	
			(void) free(yyvsp[0].word);
			}
break;
case 67:
#line 749 "gestru.y"
{
			yyval.integer=yyvsp[0].integer;
			if (yyvsp[0].integer>255) {
			  (void) yyerror("Unexpected value (above 255)");
			  yyval.integer=0;
			  } 
			}
break;
case 68:
#line 759 "gestru.y"
{
			if (yyvsp[0].integer>65535) {
			  (void) yyerror("Unexpected value (above 'FFFF')");
			  yyvsp[0].integer=0;
			  } 
			yyval.integer=yyvsp[0].integer;
			(void) asprintf(&(yyval.string),"%04ld",yyvsp[0].integer);
			}
break;
case 69:
#line 768 "gestru.y"
{
			if (yyvsp[0].integer>65535) {
			  (void) yyerror("Unexpected value (above 'FFFF')");
			  yyvsp[0].integer=0;
			  } 
			yyval.integer=yyvsp[0].integer;
			(void) asprintf(&(yyval.string),"%04lx",yyvsp[0].integer);
			}
break;
case 70:
#line 779 "gestru.y"
{
			yyval.integer=0;
			}
break;
case 71:
#line 783 "gestru.y"
{
			yyval.integer=1;
			}
break;
case 72:
#line 787 "gestru.y"
{
			yyval.integer=2;
			}
break;
case 73:
#line 791 "gestru.y"
{
			yyval.integer=3;
			}
break;
case 74:
#line 795 "gestru.y"
{
			yyval.integer=4;
			}
break;
case 75:
#line 799 "gestru.y"
{
			yyval.integer=5;
			}
break;
case 76:
#line 803 "gestru.y"
{
			yyval.integer=6;
			}
break;
case 77:
#line 809 "gestru.y"
{
			yyval.integer=-1;
			}
break;
case 78:
#line 813 "gestru.y"
{
			yyval.integer=+1;
			}
break;
case 79:
#line 817 "gestru.y"
{
			yyval.integer=+1;
			}
break;
case 84:
#line 832 "gestru.y"
{
			(void) free(yyvsp[0].word);
			yyval.word=(char *)0;
			}
break;
case 85:
#line 839 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%ld",yyvsp[0].integer);
			}
break;
case 86:
#line 843 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%lx",yyvsp[0].integer);
			}
break;
case 87:
#line 847 "gestru.y"
{
			(void) asprintf(&(yyval.string),"%s",ykeyword);
			}
break;
case 88:
#line 851 "gestru.y"
{
			yyval.string=yyvsp[0].string;
			}
break;
#line 2257 "gestru.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
