/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define low level management routines to	*/
/*	handle SMTP protocol exchange with	*/
/*	remote site.				*/
/*						*/
/************************************************/
#ifndef LVLEML
#define LVLEML
#include	"unidev.h"
#include	"unieml.h"
#include	"gesipc.h"
#include	"comeml.h"

#define	SESSION	"SID:"	/*Session ID		*/
#define	TRANSIT	"TRT:"	/*transit ID		*/

#define	BADRCPT	10	/*max number of bad RCPT*/
#define	DATADOT	".."	/*Email '.\n' convert	*/

/*head line about the virus Checker		*/
#define	VCHK	"Virus-checker"

typedef	struct	{	/*stream definition	*/
	char *title;	/*stream title		*/
	char *seq;	/*stream unique seq num	*/
	int ready;	/*stream is ready	*/
	int numline;	/*number of line in msg	*/
	char **msg;	/*stream message	*/
	}STRMTYP;

extern void eml_doorgn(CTTYP *contact,char *nip);
extern int eml_setpop3tls(TLSFILE *tls);
extern int eml_setimaptls(TLSFILE *tls);
extern int eml_checkviapop3(TLSFILE *tls,char *username,char *password);
extern int eml_checkviaimap(TLSFILE *tls,char *rmtauth,char *authport,char *username,char *password);
extern void eml_opensession(CTTYP *contact);
extern void eml_resetsession(CTTYP *contact);
extern void eml_closesession(CTTYP *contact);
extern SCODTYP eml_docontact(CTTYP *contact);
extern char *eml_xchgmsg(BPTR *bptr,u_long pool,char *fmt,...);
extern int eml_sendmsg(BPTR *bptr,u_long pool,time_t mxtime,char *fmt,...);
extern void eml_report(CTTYP *contact,int status,char *cmd);
extern void eml_remdispatch(CTTYP *cta);
extern int eml_checkehlo(CTTYP *cta,char *buffer,char sep);
extern int eml_dispatch(CTTYP *contact);
extern int eml_addheaderpart(CTTYP *cta,char **strlst);
extern int eml_rmemailparts(CTTYP *cta);
extern int eml_mergeemaildata(CTTYP *cta);
extern void eml_droptrust(CTTYP *cta);
extern char **eml_gettrust(char *sessionid);
extern int eml_collecttrust(CTTYP *cta);
extern SCODTYP eml_collectdata(CTTYP *cta);
extern STRMTYP *eml_collectstream(STRMTYP *stream,CTTYP *cta);
extern STRMTYP *eml_mkstream(char *title,char *seq,char *msg);
extern STRMTYP *eml_freestream(STRMTYP *stream);
extern int eml_sendstream(CTTYP *cta,STRMTYP *stream);
extern int eml_poststream(BPTR *bptr,STRMTYP *stream);
extern STRMTYP *eml_findstream(char **data);
extern void eml_dummyfrm(CTTYP *contact);
#endif
